 ///////////////////////////////=====================================
/// MLFC NH4 MANAGER EA version 2.0
/// This EA monitor the pair for conditions of nanningbob 4h v5 strategy
/// http://www.forexfactory.com/showthread.php?t=246113
/// The EA output some conditions in a file that can be use by MLFXNH4 panel monitor.
/// Drop this ea on many pairs (H4) and use the panel to scan all the pairs.  Panel will show
/// pairs with signals/pairs that merit attention.
/// All ea use in the strategy are built in this EA and can be invoke (activate) using the appropriate flag
/// EA sent visual contents of pair to the panel.  Use modified SIXTH indicator provided.
/// The SIXTH mod only make sure that golden/green lines have a unique name per pair.
///
/// The ea also has options to manage opened orders.
/// Take profit mode:
/// 0- fixed with level: set TP1 to TP3 and Lots1r,Lots2r to the value you want for take profit and partial lot closure
/// 1- atr with level: set ATR.Period and ATR.Multiplicator for TP1.  Tp2 and Tp3 are offset added to tp1.  Use Lots1r and Lots2r for partial lot closure
/// 2- TP1 is the green line.  TP2 and TP3 are offset added to TP1.Use Lots1r and Lots2r for partial lot closure
/// 3- TP1 is the middle BBand. "       "      "
/// 4- TP1 is when Stochastic 733 reach a desired level (use StoCTP.LevelUp/Dn) to set these level.  "         "
/// In all case, when a partial closure is desired at TP1, when price reach TP1, order is BE
/// If partial close at TP2, stoploss is set at TP1.
///
/// Trailing can be activated too.  You can select after with TP level you want it to start.  Default is after TP3.
///
/// EA default to basket mode when more than 1 order is added to a pair.
/// Set the amount of money or pips you want to make with opened order for them to close.
///
///---------------------------------------------------------
/// _EA Created_
/// (c) July 2010, by MLFX, Martin Lemire
///---------------------------------------------------------
/// _Revision_
/// 2010/08/11
/// v1.1 : correct the comment parameter in PlaceBuy and PlaceSell functions.  Thanks to mtbf40!
/// 2010/08/17-
/// v2.0 : - parameter are registered to be modified by the Panel only.  No more parameters in EA
///        - add monitoring/control of EA5 and EA7
///        - add monitoring of FX5 Divergence MACD
///        - commands can be passed to MT4 thru the panel (CLOSE, OPEN ORDER, etc...)
///        - add 4 new take profit mode 
///        - add Spread, Drawdown, takeprofit mode, basket mode columns
///        - new EAS that trigs an order when Sto7-3-3 cross upper/lower bound (85/15) and 1MA cross 3MA
///        
/// 2010/08/25
/// v2.1   - Takeprofit value on TP line wasn't changing dynamically. 
///        - when manually placing a sell, arrow wasn't in the good orientation (trade yes but not graphically).
///////////////////////////-----------------------------------------
//////////SCB/////////////
/////////////////////////
#property copyright "Copyright  2010, Martin Lemire (MLFX)"
#property link      "mlfx@mldlfx.com"
#include <stderror.mqh>
#include <stdlib.mqh>

#define VARTYPE_BOOLEAN 1
#define VARTYPE_NUMBER  2
#define VARTYPE_DOUBLE  3
#define VARTYPE_STRING  4
string GlobalRegister;  //Var that contains registered parameters

//---------------------------------------------------------------------------------------
//ROBOT PARAMETERS
string version                           = "nh4Manager_v2.1";  //EA version
string prefix                            = "mlfxnh4";

int    MagicNumber                = 0;
string _sep0                      = "--- Set Entry EA --------------------";
bool   EA1                        = false;
bool   EA2                        = false;
bool   EA3                        = false;
bool   EA4                        = false;
bool   EA5                        = false;
bool   EA7                        = false;
bool   EAS                        = false; //Based on Sto733
string _EAOrderType               = "0-automatic,1-BUY,2-SELL";
int    EAOrderType                = 0; 
bool   EAReentry                  = false;
bool   CloseOnOppositeOrder       = true;

double Lots                       = 0.05;

//extern string _TPSL                      = "*** TakeProfit Mode ***";
int    TP.Mode                    = 1;
int    TPallmode.BEpips           = 1; //Applied to all mode when TakeProfit1 is reach, SL set to BE+BEpips
string TPMODE0                    = "*** Mode 0: fixed *** ";
double TPmode0.TakeProfit1        = 40;
double TPmode0.Lots1r             = 100; //% of lot to close at this TP
double TPmode0.TakeProfit2        = 50;
double TPmode0.Lots2r             = 50; //% of remaining lot to close at this TP
double TPmode0.TakeProfit3        = 100;
string TPMODE1                    = "*** Mode 1: atr *** ";
int    TPmode1.atrTimeframe       = 0; //0-current time frame
int    TPmode1.atrPeriod          = 14;          
double TPmode1.atrMultiplicator   = 1.2;
bool   TPmode1.atrNoSundayData    = true;
double TPmode1.Lots1r             = 100; //% of lot to close at this TP
double TPmode1.TakeProfit2        = 50; //nb pips add to atrTP
double TPmode1.Lots2r             = 50; //% of remaining lot to close at this TP
double TPmode1.TakeProfit3        = 100; //nb pips add to atrTP2
string TPMODE2                    = "*** Mode 2: Green Lines *** ";
double TPmode2.Lots1r             = 100; //% of lot to close at this TP (green level)
double TPmode2.TakeProfit2        = 50; //nb pips add to greenline TP
double TPmode2.Lots2r             = 50; //% of remaining lot to close at this TP
double TPmode2.TakeProfit3        = 100; //nb pips add to green line TP2
string TPMODE3                    = "*** Mode 3: Middle Band *** ";
double TPmode3.Lots1r             = 100; //% of lot to close at this TP (green level)
double TPmode3.TakeProfit2        = 50; //nb pips add to greenline TP
double TPmode3.Lots2r             = 50; //% of remaining lot to close at this TP
double TPmode3.TakeProfit3        = 100; //nb pips add to green line TP2
string TPMODE4                    = "*** Mode 4: stochastic 733 *** ";
int    TPmode4.LevelUp            = 75;
int    TPmode4.LevelDn            = 25;
double TPmode4.Lots1r             = 100; //% of lot to close at this TP (green level)
double TPmode4.TakeProfit2        = 50; //nb pips add to greenline TP
double TPmode4.Lots2r             = 50; //% of remaining lot to close at this TP
double TPmode4.TakeProfit3        = 100; //nb pips add to green line TP2

string TPMODE5                    = "*** Mode 5: stochastic 733 cross with stochastics14-3-5 *** ";
double TPmode5.Lots1r             = 100; //% of lot to close at this TP
double TPmode5.TakeProfit2        = 50; //nb pips add to price cross
double TPmode5.Lots2r             = 50; //% of remaining lot to close at this TP
double TPmode5.TakeProfit3        = 100; //nb pips add to TP2

string TPMODE6                    = "*** Mode 6: Upper BB *** ";
double TPmode6.Lots1r             = 100; //% of lot to close at this TP
double TPmode6.TakeProfit2        = 50; //nb pips add to upper BB
double TPmode6.Lots2r             = 50; //% of remaining lot to close at this TP
double TPmode6.TakeProfit3        = 100; //nb pips add to TP2

string TPMODE7                    = "*** Mode 7: Lower BB *** ";
double TPmode7.Lots1r             = 100; //% of lot to close at this TP
double TPmode7.TakeProfit2        = 50; //nb pips add to lower BB
double TPmode7.Lots2r             = 50; //% of remaining lot to close at this TP
double TPmode7.TakeProfit3        = 100; //nb pips add to TP2

string TPMODE8                    = "*** Mode 8: Sto733 cross MACD *** ";
double TPmode8.Lots1r             = 100; //% of lot to close at this TP
double TPmode8.TakeProfit2        = 50; //nb pips add to lower BB
double TPmode8.Lots2r             = 50; //% of remaining lot to close at this TP
double TPmode8.TakeProfit3        = 100; //nb pips add to TP2

string _SL                        = "*** STOPLOSS *** ";
int    StopLoss                   = 0;   //Set to 0 for automatic calculation or a given nummber
string _Trailing_                 = "*** Trailing Mode 0-off, 1-dist, 2-candle ***";
int    TS_Mode                    = 0; //0-off, 1-regular, 2-by candle, 3-both
int    TS_StartAtTPLevel          = 3; //Inclusive
int    TS_SetBreakEvenAt          = 20;   //0-off,when profit reach these pips, SL set to breakeven+LockPips
int    TS_LockPips                = 5;
int    TSmode1.TrailingStop       = 35;
int    TSmode1.TrailingStep       = 2;   //Diff between market price and SL
int    TSmode2.CandleTrailing     = 0;

string _Basket                    = "**** MultiLevel MODE (Basket) ******" ;
bool   BASKET_Use                 = true;
bool   BASKET_pipsGroupUse        = false;
double BASKET_targetpipsGroup     = 5; //Total order pips reached: close all
bool   BASKET_targetAmountUse     = true;
double BASKET_targetAmount        = 10; //in $ - Target amount reached: close all
double BASKET_targetpct           = 0; //Target percent of capital reach in profit: close all orders
//bool   BASKET_targetBreakEven     = false; //when true, orders not closed when target is reach.  Instead, when
                                           //target is reach, SL is Set at breakeven for all open order and this
                                           //SL can be trail with following parameters
//int    BASKET_targetTrailingStop  = 
                                           

string _Order_                    = "******* Order info ********";
bool   EntryAddOrder              = true;  //true-add order, false:orders are not placed (just an arrow)
int    MaxOrders                  = 10;
int    OrderRetry                 = 3;
int    DelayBetweenRetry          = 2000;
double MaxSpread                  = 30;
int    Slippage                   = 2;

string _Misc_                     = "********** Misc ***********";
int    BrokerOffsetFromGMT=1;
bool   EntryAlert                 = false;
bool   EntryEmail                 = false;
bool   ReportEmail                = false;
string ReportSubject              = "NH4MLFX";

string _Panel                     = "*** NH4 PANEL SETTING ****";
int    Proximity                  = 25; //+- pips from lines
string _PanelColor                = "0=empty,1=yellow,2=green";
string _PanelColor2               = "3=red,-1=gray";
string ColorPrimaryGood           = "2";
string ColorPrimaryNear           = "1";
string ColorPrimaryNo             = "0";
string ColorSecondaryGood         = "2";
string ColorSecondaryNear         = "1";
string ColorSecondaryNo           = "0";
string ColorRWBGood               = "2";
string ColorRWBNear               = "1";
string ColorRWBNo                 = "0";
string ColorInside                = "2";
string ColorOutside               = "2";
string ColorInOutNear             = "1";
string ColorInOutNo               = "0";
string ColorEArunning             = "2";
string ColorEAstopped             = "3";
string ColorEANo                  = "-1";
string ColorEAreentry             = "1";


//--------------------------------------
//Candle timer
string FontName="Courier";
int    FontSize=10;
color  FontColor=White;
int    Corner=3;// values [0-3]
int    XDistance=10;
int    YDistance=0;
int    YDistanceSignal=17;
int    lenbase;
string s_base=":...:...:...:...:";
int    objtick;

//--------------------------------------
//Tick monitor
string TickDisplay;
int    TickRotate=0;

double PointValue;
double LastBalance;
bool bNewBar;
double DrawDown;

string msgMisc, msg, msgError;
int tCurrent;
bool ECNBroker;

int OrderCountBuy, OrderCountSell;
double buyorderprofit,sellorderprofit;
double sellpips,buypips;
double lastbuyopenprice=0;
double lastsellopenprice=0;
int   lastbuyopentime;
int   lastsellopentime;
double LastBuyLots=0;
double LastSellLots=0;

double MACD[];
int  SlippageClose;

bool EA1_completed = false;
bool EA2_completed = false;
bool EA3_completed = false;
bool EA4_completed = false;
bool EA5_completed = false;
bool EA7_completed = false;
bool EAS_completed = false;

double onesixth=0;
double twosixth=0;
double threesixth=0;
double foursixth=0;
double fivesixth=0;

double MA=0;
double MA1=0;
double BBup=0;
double BBdown=0;
  
double MACDsignal=0;
double Sto733=0;
double Sto1435=0;
double dMACD; //Rescale MACD


int PanelLastInfoSent =0;
int PanelDelayStart=5; //sec
int PanelDelay=5;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {

   //Automatic Magicnumber attribution
   //if ( !GlobalVariableCheck(StringConcatenate(prefix,Symbol(),Period())) ) {
   //  MagicNumber = TimeCurrent();
   //  GlobalVariableSet(StringConcatenate(prefix,Symbol(),Period()), MagicNumber);
   //} else {
   //  MagicNumber = GlobalVariableGet(StringConcatenate(prefix,Symbol(),Period()));
   //}


   //Broker Digits Assignation
   PointValue = Point;
   if (Digits==5) PointValue = 0.0001;
   else if (Digits==3) PointValue = 0.01;

   //Candle display timer init
   lenbase=StringLen(s_base);
   
   Comment("....::::[[[ "+version+" ]]]::::....\nStarting...");

   LastBalance = AccountBalance();

   ArrayResize(MACD, Bars);

   SlippageClose = Slippage;

   DeleteBEline();
   DeleteTPline();

   EA1_completed=false;EA2_completed=false;EA3_completed=false;EA4_completed=false;EA5_completed=false;EA7_completed=false;EAS_completed=false;

   ParamReloadLastKnowSetup();
   
   ParamSetAllRegister(); //Reconstruct the EA params register

   return(0);
   
}

void DeleteBEline() {
   if(ObjectFind(StringConcatenate(MagicNumber,Symbol(),Period(),"_BE" ))!=-1) {
     ObjectDelete(StringConcatenate(MagicNumber,Symbol(),Period(),"_BE" )); 
     ObjectDelete(StringConcatenate(MagicNumber,Symbol(),Period(),"_BE_label" )); 
   }
}  

void DeleteTPline() {
   if(ObjectFind(StringConcatenate(MagicNumber,Symbol(),Period(),"_TP" ))!=-1) {
     ObjectDelete(StringConcatenate(MagicNumber,Symbol(),Period(),"_TP" )); 
     ObjectDelete(StringConcatenate(MagicNumber,Symbol(),Period(),"_TP_label" )); 
   }
}  
void DeleteREline() {
   if(ObjectFind(StringConcatenate(MagicNumber,Symbol(),Period(),"_RE" ))!=-1) {
     ObjectDelete(StringConcatenate(MagicNumber,Symbol(),Period(),"_RE" )); 
     ObjectDelete(StringConcatenate(MagicNumber,Symbol(),Period(),"_RE_label" )); 
   }
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {

   //ObjectDelete(Symbol()+tf2txt(Period())+"BarTimer");
   //ObjectDelete(Symbol()+tf2txt(Period())+"BarTimerSignal");
   //ObjectDelete(Symbol()+Period()+ "EA" );

   DeleteBEline();
   DeleteTPline();
   DeleteREline();

   objtick=0;

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
string msgTS;
int i;
int Retry;

  msgMisc = "";

  //DisplayCandleTimer();
  
  tCurrent = TimeCurrent() - BrokerOffsetFromGMT*3600.0 ; //Actual server time minus offset from GMT

  msg = "";
   
  bNewBar = NewBar();   //New bar?
  if(bNewBar) {
     objtick++;
  }
  
  switch(TickRotate)
  {
      case 0:  TickDisplay=" -- "; TickRotate++; break;
      case 1:  TickDisplay=" \ "; TickRotate++; break;
      case 2:  TickDisplay=" | "; TickRotate++; break;
      case 3:  TickDisplay=" / "; TickRotate=0; break;
  }

  ExecuteCommand();

  Strategy();
  
  string tsVer = "....::::[[[ "+version+" ]]]::::.... "+TickDisplay; //+"\nBroker: "+getDayTxt(DayOfWeek())+" "+lsFormatNumber(TimeHour(TimeCurrent()))+":"+lsFormatNumber(TimeMinute(TimeCurrent()))+"\nGMT: "+getDayTxt(getGMTday())+" "+lsFormatNumber(TimeHour(tCurrent))+":"+lsFormatNumber(TimeMinute(tCurrent)) ;
 
  string sLabelEA;
  sLabelEA=" ";  
  if(EA1) {
    sLabelEA = "EA#1 Running...";
    tsVer = StringConcatenate(tsVer,"\n\n>>>> EA1 Running... ");
  }
  if(EA2) {
    tsVer = StringConcatenate(tsVer,"\n\n>>>> EA2 Running...");
    sLabelEA = "EA#2 Running...";
  }
  if(EA3) {
    tsVer = StringConcatenate(tsVer,"\n\n>>>> EA3 Running...");
    sLabelEA = "EA#3 Running...";
  }
  if(EA4) {
    tsVer = StringConcatenate(tsVer,"\n\n>>>> EA4 Running...");
    sLabelEA = "EA#4 Running...";
  }
  if(EA5) {
    tsVer = StringConcatenate(tsVer,"\n\n>>>> EA5 Running...");
    sLabelEA = "EA#5 Running...";
  }
  if(EA7) {
    tsVer = StringConcatenate(tsVer,"\n\n>>>> EA7 Running...");
    sLabelEA = "EA#7 Running...";
  }
  if(EAS) {
    tsVer = StringConcatenate(tsVer,"\n\n>>>> EAS Running...");
    sLabelEA = "EA#S Running...";
  }

  if (ObjectFind(Symbol()+Period()+ "EA" ) == -1) {
      ObjectCreate(Symbol()+Period()+ "EA", OBJ_TEXT,0, 0, 0);
      ObjectSet(Symbol()+Period()+ "EA", OBJPROP_COLOR, Green);
      //ObjectSet(Symbol()+Period()+"EA", OBJPROP_XDISTANCE,0);
      //ObjectSet(Symbol()+Period()+"EA", OBJPROP_YDISTANCE,10);
      ObjectSet(Symbol()+Period()+ "EA", OBJPROP_CORNER,1);
  }
  ObjectSetText(Symbol()+Period()+ "EA", sLabelEA, 12, "Courier New", Green);

  
  if(!SpreadOK()) {
    if (Digits==3 || Digits==5) {
      tsVer = StringConcatenate(tsVer,"\n*** SPREAD TOO HIGH: ",DoubleToStr(NormalizeDouble(MarketInfo(Symbol(), MODE_SPREAD)*0.1,1),1)," ***\n");
    } else {
      tsVer = StringConcatenate(tsVer,"\n*** SPREAD TOO HIGH: ",DoubleToStr( NormalizeDouble( MarketInfo(Symbol(), MODE_SPREAD),0),0)," ***\n");
    }
  }
  
  if (ECNBroker==true) {
    msg = StringConcatenate(msg,"\nBroker: ECN ", Digits, " digits");
  } else {
    msg = StringConcatenate(msg,"\nBroker: ", Digits, " digits");
  }

  if (Digits == 5 || Digits == 3) {
     msg = StringConcatenate(msg,"\nSpread: ", DoubleToStr(NormalizeDouble(MarketInfo(Symbol(), MODE_SPREAD)*0.1,1),1));
  } else {
     msg = StringConcatenate(msg,"\nSpread: ", DoubleToStr( NormalizeDouble(MarketInfo(Symbol(), MODE_SPREAD),0),0 ));
  }

  DrawDown = (buyorderprofit+sellorderprofit)/AccountBalance() * 100;
  
  tsVer = StringConcatenate(tsVer, "\n\n-----------------------------------------------------------",  
                                   "\n",prefix," : ",(OrderCountBuy+OrderCountSell),"   $",DoubleToStr(buyorderprofit+sellorderprofit,2),"  (",DoubleToStr(sellpips+buypips,1),"pips)",
                                   "\nBUY:  ",OrderCountBuy,"  $",DoubleToStr(buyorderprofit,2),"  (",DoubleToStr(buypips,1),"pips)",
                                   "\nSELL: ",OrderCountSell,"  $",DoubleToStr(sellorderprofit,2),"  (",DoubleToStr(sellpips,1),"pips)",
                                   "\nDD: ",DoubleToStr(DrawDown,1),"%",
                                   "\n-----------------------------------------------------------",  
                                   msg,
                                   "\n-----------------------------------------------------------",  
                                   "\nAccount Balance:     "+DoubleToStr(AccountBalance(),2),
                                   "\nAccount Equity:      "+DoubleToStr(AccountEquity(),2),
                                   "\nAccount Free Margin: "+DoubleToStr(AccountFreeMargin(),2),
                                   "\n-----------------------------------------------------------",  
                                   "\n",msgMisc,
                                   "\n\n",msgError);
  Comment(tsVer);       

  ObjectDelete("Cmmt");
  if((OrderCountBuy+OrderCountSell) > 0) {
    ObjectCreate("Cmmt", OBJ_TEXT, 0, Time[0]+Period()*60*6, Bid);
    ObjectSetText("Cmmt"," $"+DoubleToStr(sellorderprofit+buyorderprofit,2)+"  ("+DoubleToStr(sellpips+buypips,1)+"pips)",8,"Arial",White);
  }
  
  if(ReportEmail && LastBalance!=AccountBalance() ) {
    string sSign;
    double Difference;
    double DiffPc;
    Difference = AccountBalance()-LastBalance ;
    DiffPc = Difference / LastBalance * 100;
    if(Difference > 0) sSign="+"; else sSign="-";
    SendMail(ReportSubject+" "+sSign+" "+DoubleToStr(DiffPc,2)+"%", "$"+DoubleToStr(LastBalance,2)+" "+sSign+" $"+DoubleToStr(Difference,2)+" = $"+DoubleToStr(AccountBalance(),2)+"  ::::>> "+sSign+" "+DoubleToStr(DiffPc,2)+"%");
    LastBalance = AccountBalance();
  }

  return(0);
}

//+------------------------------------------------------------------+
bool NewBar()
{
   static datetime dt = 0;
   
   if (Time[0] != dt)
   {
      dt = Time[0];
      return(true);
   } 
   return(false);
}

//---------------------------------------------------------------------------
string lsFormatNumber( int nNumber ) {
  if (nNumber<10) return("0"+nNumber);
  return(nNumber);
}


//---------------------------------------------------------------------------
string tf2txt(int tf)
{
   if (tf == PERIOD_M1)    return("M1");
   if (tf == PERIOD_M5)    return("M5");
   if (tf == PERIOD_M15)    return("M15");
   if (tf == PERIOD_M30)    return("M30");
   if (tf == PERIOD_H1)    return("H1");
   if (tf == PERIOD_H4)    return("H4");
   if (tf == PERIOD_D1)    return("D1");
   if (tf == PERIOD_W1)    return("W1");
   if (tf == PERIOD_MN1)    return("MN1");
   
   return("??");
}




//Display a progression bar of left time on current candle
void DisplayCandleTimer() {
   int i=0,sec=0;
   double pc=0.0;
   string time="",s_end="",s_beg="";
   if (ObjectFind(Symbol()+tf2txt(Period())+"BarTimer") == -1) {
     ObjectCreate(Symbol()+tf2txt(Period())+"BarTimer" , OBJ_LABEL,0,0,0);
     ObjectSet(Symbol()+tf2txt(Period())+"BarTimer", OBJPROP_XDISTANCE, XDistance);
     ObjectSet(Symbol()+tf2txt(Period())+"BarTimer", OBJPROP_YDISTANCE, YDistance+12);
     ObjectSet(Symbol()+tf2txt(Period())+"BarTimer", OBJPROP_CORNER, Corner);
   }

   sec=TimeCurrent()-Time[0];
   i=(lenbase-1)*sec/(Period()*60);
   pc=100.0*sec/(Period()*60);
   if(i>lenbase-1) i=lenbase-1;
   if(i>0) s_beg=StringSubstr(s_base,0,i);
   if(i<lenbase-1) s_end=StringSubstr(s_base,i+1,lenbase-i-1);
   time=StringConcatenate(DoubleToStr(pc,0),"% ",s_beg,"|",s_end);
   ObjectSetText(Symbol()+tf2txt(Period())+"BarTimer", time, FontSize, FontName, FontColor);
   time=""; s_beg=""; s_end="";
     
   //ObjectSetText(Symbol()+tf2txt(Period())+"BarTimerSignal", " ", FontSize, FontName, FontColor);
}

//-----------------------------------------------------------
// getGMTday
// Return the GMT day from server day based on the offset with broker
// 0-Sunday,1,2,3,4,5,6
//------------------------------------------------------------
int getGMTday() {
int CurrentDay = DayOfWeek();

  if(BrokerOffsetFromGMT>=0) {  
    if (TimeHour(TimeCurrent()) >= TimeHour(TimeCurrent() - BrokerOffsetFromGMT*3600.0) ) return(CurrentDay);  //We are at the same day
    CurrentDay--; //GMT is still yesterday
    if (CurrentDay<0) CurrentDay=6;
    return(CurrentDay);
  } else {
    if (TimeHour(TimeCurrent()) <= TimeHour(TimeCurrent() - BrokerOffsetFromGMT*3600.0) ) return(CurrentDay);  //We are at the same day
    CurrentDay++; //GMT is already tomorrow
    if (CurrentDay>6) CurrentDay=0;
    return(CurrentDay);
  }

}

string getDayTxt( int nDay ) {
  switch(nDay) {
    case 0: return("Sunday");
    case 1: return("Monday");
    case 2: return("Thuesday");
    case 3: return("Wednesday");
    case 4: return("Thursday");
    case 5: return("Friday");
    case 6: return("Saturday");
    default: return("?");
  }
}
  
string lf(int num) {
  if(num<10) return("0"+num);
  return(num+"");
}

double iifd(bool bOp, double val1, double val2) {
  if(bOp) return(val1);
  return(val2);
}


void BBU(int MN,int SetBreakEvenAt, int LockPips, bool tOn, int TrailingStop, int TrailingStep ){
   
   for(int i=OrdersTotal()-1;i>=0;i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(( OrderSymbol()==Symbol() && OrderMagicNumber()==MN) ){
            if(SetBreakEvenAt>0) BreakEvenPositions(SetBreakEvenAt, LockPips);
            if(tOn) TrailingPositions(MN, TrailingStop, TrailingStep);
         }
      }
   }
}

void TrailingPositions(int Magic, int TrailingStop, int TrailingStep){
   double pBid,pAsk,pp;
   if(OrderType()==OP_BUY){
      pBid=MarketInfo(OrderSymbol(),MODE_BID);
      if( (pBid-OrderOpenPrice())>TrailingStop*PointValue){
         if((OrderStopLoss()<pBid-(TrailingStop+TrailingStep-1)*PointValue && OrderStopLoss()>0) || OrderStopLoss()==0){
            ModifyStopLoss(pBid-TrailingStop*PointValue);
         }
      }
   }
   if(OrderType()==OP_SELL){
      pAsk=MarketInfo(OrderSymbol(),MODE_ASK);
      if( OrderOpenPrice()-pAsk>TrailingStop*PointValue){
         if(OrderStopLoss()>pAsk+(TrailingStop+TrailingStep-1)*PointValue || OrderStopLoss()==0){
            ModifyStopLoss(pAsk+TrailingStop*PointValue);
         }
      }
   }
}
void BreakEvenPositions(int SetBreakEvenAt, int LockPips){
   double pBid,pAsk,pp;
   if(OrderType()==OP_BUY){
      pBid=MarketInfo(OrderSymbol(),MODE_BID);
      if( (pBid-OrderOpenPrice())>SetBreakEvenAt*PointValue && ((OrderStopLoss()<OrderOpenPrice() && OrderStopLoss()>0) || OrderStopLoss()==0)  ){
        ModifyStopLoss(OrderOpenPrice()+LockPips*PointValue);
      }
   }
   if(OrderType()==OP_SELL){
      pAsk=MarketInfo(OrderSymbol(),MODE_ASK);
      if( OrderOpenPrice()-pAsk>SetBreakEvenAt*PointValue && (OrderStopLoss()>OrderOpenPrice() || OrderStopLoss()==0) ){
        ModifyStopLoss(OrderOpenPrice()-LockPips*PointValue);
      }
   }
}


void ModifyStopLoss(double ldStopLoss){
   bool fm;
  
   switch(OrderType()) {
     case OP_BUY:
       if((Bid - ldStopLoss)<MarketInfo(Symbol(),MODE_STOPLEVEL)) return;
     break;
     case OP_SELL:
        if((ldStopLoss-Ask)<MarketInfo(Symbol(),MODE_STOPLEVEL)) return;
     break;
   }
   fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE);
   Print("StopLoss modify for "+OrderTicket()+" for "+ldStopLoss);
   if(fm>0) OrderSelect(OrderTicket(), SELECT_BY_TICKET); //Reselect to reload order info
}




void TrailingPositionsByCandle(int MN, int CandleCount, bool bTrailAlways, int TimeFrame) {
double dLevel;
int iBarS;
   for(int i=OrdersTotal()-1;i>=0;i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(( OrderSymbol()==Symbol() && OrderMagicNumber()==MN) ){
           iBarS = iBarShift(NULL,TimeFrame,OrderOpenTime(),false);
           if(iBarS!=-1) if(Time[iBarS]==Time[0]) continue;

           dLevel = 0;
           if (OrderType() == OP_BUY) 
             dLevel = Low[iLowest(Symbol(), TimeFrame, MODE_LOW, CandleCount, 1)]; //- 1.0*PointValue;
           else if(OrderType()==OP_SELL) 
             dLevel = High[iHighest(Symbol(), TimeFrame, MODE_HIGH, CandleCount, 1)]; //+ 1*PointValue;
           if(dLevel>0) {
             if (OrderType() == OP_BUY && ((OrderStopLoss() < NormalizeDouble(dLevel,Digits) && OrderStopLoss()>0) || OrderStopLoss()==0) && (bTrailAlways || (!bTrailAlways && OrderOpenPrice() < NormalizeDouble(dLevel,Digits)))) {
               ModifyStopLoss(dLevel+PointValue);
             } else if (OrderType() == OP_SELL && (OrderStopLoss()==0 || OrderStopLoss() > NormalizeDouble(dLevel,Digits)) && (bTrailAlways || (!bTrailAlways && OrderOpenPrice() > NormalizeDouble(dLevel,Digits)))) {
                ModifyStopLoss(dLevel-PointValue);
             }
           }
         }
      }
   }
}

int GetNewTicketId( int orderop, int MN) {
int i;

  RefreshRates();
  for(i=0;i<OrdersTotal();i++) {
    if(OrderSelect(i, SELECT_BY_POS)) {
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MN) {
         if(OrderType()==orderop) {
           return(OrderTicket());
         }
      }
    }
  }
  return(0);
}

//------------------------------------------------------
// CloseAllOpenedOrders
int CloseAllOpenedOrders(int Magic, bool bKeepSecured)
{
  int total=OrdersTotal();

  for(int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic && OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_BUY)
      {
        if (!(bKeepSecured && OrderStopLoss()>=OrderOpenPrice())) {
          RefreshRates();
          if(OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),SlippageClose*(PointValue/Point))) {
            ObjectCreate(Symbol()+tf2txt(Period())+"myz"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], Low[0]-(7*PointValue));
            ObjectSetText(Symbol()+tf2txt(Period())+"myz"+DoubleToStr(objtick,0),"C",8,"Arial",White);
          }
        }
      }
      if(OrderType()==OP_SELL)
      {
        if (!(bKeepSecured && OrderStopLoss()<=OrderOpenPrice())) { 
          RefreshRates();
          if (OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),SlippageClose*(PointValue/Point))) {
            ObjectCreate(Symbol()+tf2txt(Period())+"myz"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], Low[0]-(7*PointValue));
            ObjectSetText(Symbol()+tf2txt(Period())+"myz"+DoubleToStr(objtick,0),"C",8,"Arial",White);
          }
        }
      }
      
    }
  }
  return(0);
}


int WriteToFile( string sData) {
		// create / open hst file		
int HstHandle;		
		HstHandle = FileOpen(Symbol()+".nh4", FILE_BIN|FILE_WRITE);
		if(HstHandle < 0) {
			Print("Error: can\'t create / open file: " + Symbol()+ ".nh4");
			return(-1);
		}
		FileWriteString(HstHandle, sData+"[EOT]", StringLen(sData)+5);
		FileClose(HstHandle);
}		
		

//------------------------------------------------------------------------------------
//Valid spread
// Idea from QuickSilver suggested by Verb
//------------------------------------------------------------------------------------
bool SpreadOK() 
{
  if(IsTesting()) return(true);

   double iSpread, rSpread; 
   string iSpread1, rSpread1;
   
   iSpread = MaxSpread * PointValue/Point ;
   rSpread = NormalizeDouble(MarketInfo(Symbol(), MODE_SPREAD),0);      
         
   if (rSpread > iSpread) 
   {
      if (Digits == 5 || Digits == 3) 
      {
         rSpread1 = DoubleToStr(NormalizeDouble(MarketInfo(Symbol(), MODE_SPREAD)*0.1,1),1);
         iSpread1 = DoubleToStr(MaxSpread,1);  
      }   
      else 
      {
         rSpread1 = DoubleToStr(rSpread,0); 
         iSpread1 = DoubleToStr(MaxSpread,0);
      }      
      //Print("Trade not opened. SPREAD more than MaxSpread: ", iSpread1 + ", Current Spread: " + rSpread1);
      return (FALSE);
   }   
   
   return (TRUE);
}

//------------------------------------------------------------------------------------------------------------
int PlaceBuy(double LotMM, int StopLoss,int TakeProfit, int Slippage, int MagicNumber, string prefix , bool bCalcStopLoss=true, int nObj=1, string sComment="") {
int    Retry=0;
double TP,SL;
int    nTicket;
string sCmt="";

   sCmt = sComment;

   Retry=OrderRetry;
   while(Retry>0 && EntryAddOrder ) {
     RefreshRates();
     if (StopLoss>0 && !ECNBroker) {SL = Bid-NormalizeDouble(StopLoss*PointValue,Digits);} else {SL=0;}
     if (TakeProfit>0 && !ECNBroker) {TP = Ask+NormalizeDouble(TakeProfit*PointValue,Digits);} else {TP=0;}
        
     nTicket = OrderSend(Symbol(),OP_BUY,LotMM,NormalizeDouble(Ask,Digits),Slippage*(PointValue/Point),NormalizeDouble(SL,Digits),NormalizeDouble(TP,Digits),sCmt,MagicNumber,0,Blue); 
     if (nTicket==-1) {
        nTicket = GetLastError();
        msgError = StringConcatenate(msgError,"\n",Hour()+":"+Minute()+":"+Seconds()+" ERROR #"+nTicket+" FOR BUY : "+ErrorDescription(nTicket)+" price:"+DoubleToStr(Ask,Digits)+" SL:"+DoubleToStr(SL,Digits)+" TP:"+DoubleToStr(TP,Digits));
        Print(msgError);
        if (EntryAlert) Alert(prefix+" "+Symbol()+" "+tf2txt(Period())+": ERROR #"+nTicket+" FOR BUY : "+ErrorDescription(nTicket));
        if (EntryEmail) SendMail(prefix+" "+Symbol()+" ERROR #"+nTicket, prefix+" "+Symbol()+" "+tf2txt(Period())+": ERROR "+nTicket+" FOR BUY : "+ErrorDescription(nTicket)+"\nBalance: $"+DoubleToStr(AccountBalance(),2)+" Profit/Loss: $"+DoubleToStr(AccountProfit(),2) );
        if (EntryEmail) SendMail(prefix+" "+Symbol()+" ERROR #"+nTicket, "SL:"+DoubleToStr(SL,Digits)+" TP:"+DoubleToStr(TP,Digits));
        Retry--; if(Retry==0) break;
        Sleep(DelayBetweenRetry);
      } else {
        //dtHedgeCurrentBar = Time[0];
        if (ECNBroker && (StopLoss>0 || TakeProfit>0)) {
          if(StopLoss>0) {SL = Bid-NormalizeDouble(StopLoss*PointValue,Digits);} else {SL=0;}
          if(TakeProfit>0){ TP = Ask+NormalizeDouble(TakeProfit*PointValue,Digits);} else { TP=0;}
          if (OrderSelect(nTicket, SELECT_BY_TICKET)) {
            if(!OrderModify(nTicket,OrderOpenPrice(), SL,TP,0,Blue)) {
              msgError = StringConcatenate(msgError,"\n",Hour()+":"+Minute()+":"+Seconds()+" ERROR #"+nTicket+" FOR BUY : "+ErrorDescription(nTicket)+" price:"+DoubleToStr(Ask,Digits)+" SL:"+DoubleToStr(SL,Digits)+" TP:"+DoubleToStr(TP,Digits));
              Print(msgError);
            }
          }
        }
        msgError = StringConcatenate(msgError,"\n",prefix+" "+Hour()+":"+Minute()+":"+Seconds()+" BUY Order #"+nTicket+" added.");
        break;
      }
   }
   if (Retry==0) {
     PlotObject(99,prefix+"_BUY_FAILED:"+ErrorDescription(nTicket), Low[0]-30*PointValue, TimeCurrent());
   } else {
       PlotObject(nObj,prefix+"_BUY_SIGNAL", Low[0]-30*PointValue, TimeCurrent());
       if (EntryAlert) Alert(prefix+" "+Symbol()+" "+tf2txt(Period())+": BUY now @ "+DoubleToStr(Ask,Digits));
       if (EntryEmail) SendMail(prefix+" "+Symbol()+" BUY now!", prefix+" "+Symbol()+" "+tf2txt(Period())+": BUY now @ "+DoubleToStr(Ask,Digits)+"\nBalance: $"+DoubleToStr(AccountBalance(),2)+" Profit/Loss: $"+DoubleToStr(AccountProfit(),2));
       //GoodSignalStamp = 0;
   }
   return(nTicket);

}
//------------------------------------------------------------------------------------------------------------
int PlaceSell(double LotMM, int StopLoss,int TakeProfit, int Slippage, int MagicNumber, string prefix , bool bCalcStopLoss=true, int nObj=31, string sComment="") {
int    Retry=0;
double SL,TP;
int    nTicket;
string sCmt="";

   sCmt = sComment;
   Retry=OrderRetry;
   while(Retry>0 && EntryAddOrder) {
     //Sleep(2000);
     RefreshRates();
     if (StopLoss>0 && !ECNBroker) {SL = Ask+NormalizeDouble(StopLoss*PointValue,Digits);} else {SL=0;}
     if (TakeProfit>0 && !ECNBroker) {TP = Bid-NormalizeDouble(TakeProfit*PointValue,Digits);} else {TP=0;}

     nTicket = OrderSend(Symbol(),OP_SELL,LotMM,NormalizeDouble(Bid,Digits),Slippage*(PointValue/Point),NormalizeDouble(SL,Digits),NormalizeDouble(TP,Digits),sCmt,MagicNumber,0,Red); 
     if (nTicket==-1) {
       nTicket = GetLastError();
       msgError = StringConcatenate(msgError,"\n",Hour()+":"+Minute()+":"+Seconds()+" ERROR "+nTicket+" FOR SELL : "+ErrorDescription(nTicket)+" price:"+DoubleToStr(Bid,Digits)+" SL:"+DoubleToStr(SL,Digits)+" TP:"+DoubleToStr(TP,Digits));
       Print(msgError);
       if (EntryAlert) Alert(prefix+" "+Symbol()+" "+tf2txt(Period())+": ERROR #"+nTicket+" FOR SELL : "+ErrorDescription(nTicket));
       if (EntryEmail) SendMail(prefix+" "+Symbol()+" ERROR #"+nTicket, prefix+" "+Symbol()+" "+tf2txt(Period())+": ERROR "+nTicket+" FOR SELL : "+ErrorDescription(nTicket)+"\nBalance: $"+DoubleToStr(AccountBalance(),2)+" Profit/Loss: $"+DoubleToStr(AccountProfit(),2));
       if (EntryEmail) SendMail(prefix+" "+Symbol()+" ERROR #"+nTicket, "SL:"+DoubleToStr(SL,Digits)+" TP:"+DoubleToStr(TP,Digits));
       Retry--; if (Retry==0) break;
       Sleep(DelayBetweenRetry);
     } else {
        if (ECNBroker && (StopLoss>0 || TakeProfit>0)) {
          if(StopLoss>0) {SL = Ask+NormalizeDouble(StopLoss*PointValue,Digits);} else {SL=0;}
          if(TakeProfit>0) {TP = Bid-NormalizeDouble(TakeProfit*PointValue,Digits);} else {TP=0;}
          if (OrderSelect(nTicket, SELECT_BY_TICKET)) {
            if(!OrderModify(nTicket,OrderOpenPrice(), SL,TP,0,Red)) {
              msgError = StringConcatenate(msgError,"\n",Hour()+":"+Minute()+":"+Seconds()+" ERROR #"+nTicket+" FOR BUY : "+ErrorDescription(nTicket)+" price:"+DoubleToStr(Ask,Digits)+" SL:"+DoubleToStr(SL,Digits)+" TP:"+DoubleToStr(TP,Digits));
              Print(msgError);
            }
          }
        }
       msgError = StringConcatenate(msgError,"\n",Hour()+":"+Minute()+":"+Seconds()+" SELL Order #"+nTicket+" added.");
       //dtHedgeCurrentBar = Time[0];
       break;
     }
   }
   if (Retry==0) {
      PlotObject(99,prefix+"_SELL_FAILED:"+ErrorDescription(nTicket), High[0]+30*PointValue, TimeCurrent());
   } else {
      PlotObject(nObj,prefix+"_SELL_SIGNAL", High[0]+30*PointValue, TimeCurrent());
      if (EntryAlert) Alert(prefix+" "+Symbol()+" "+tf2txt(Period())+": SELL now @ "+DoubleToStr(Bid,Digits));
      if (EntryEmail) SendMail(prefix+" "+Symbol()+" SELL now!", prefix+" "+Symbol()+" "+tf2txt(Period())+": SELL now @ "+DoubleToStr(Bid,Digits)+"\nBalance: $"+DoubleToStr(AccountBalance(),2)+" Profit/Loss: $"+DoubleToStr(AccountProfit(),2) );
      //GoodSignalStamp = 0;
   }
   return(nTicket);
}

//------------------------------------------------------
// Close Highest order of given type
int CloseHighestOrder(int nOrderMode)
{
  int nTicket=0;
  int total=OrdersTotal();
  datetime LastP=0;

  for(int cnt=0;cnt<total;cnt++)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol())
    {
      if(nOrderMode==-1) {
        if((OrderOpenTime()<LastP && LastP!=0) || LastP==0) {
          LastP    = OrderOpenTime();
          nTicket = OrderTicket();
        }      
      } else {
        if(OrderType()==nOrderMode && nOrderMode==OP_BUY) {
          if((OrderOpenTime()<LastP && LastP!=0) || LastP==0) {
            LastP    = OrderOpenTime();
            nTicket = OrderTicket();
          }      
        }
        if(OrderType()==nOrderMode && nOrderMode==OP_SELL) {
          if((OrderOpenTime()<LastP && LastP!=0) || LastP==0) {
            LastP   = OrderOpenTime();
            nTicket = OrderTicket();
          }      
        }
      }
    }
  }
  if(nTicket>0) {
    if(OrderSelect(nTicket, SELECT_BY_TICKET)) {
      if(OrderType()==OP_BUY) {
        if(OrderClose(nTicket, OrderLots(), Bid, SlippageClose*PointValue/Point)) return(OP_BUY);
      } else {
        if( OrderClose(nTicket, OrderLots(), Ask, SlippageClose*PointValue/Point)) return(OP_SELL);
      }
    }
  }
  
  return(0);
}


//---------------------------------------------------------------------------
void PlotObject( int nObj, string sObj, double dPrice, datetime dtTime) {

//Alert("PlotObject "+nObj+" at "+DoubleToStr(dPrice,Digits)+" "+dtTime);
  if(IsTesting()) return;
  
  switch(nObj) {
    case 1: //"PHG_BUY_GOOD":
      if (ObjectCreate( sObj+"_"+dtTime,OBJ_ARROW,0, dtTime, dPrice)) {
        ObjectSet(sObj+"_"+dtTime, OBJPROP_ARROWCODE, 233 ); //SYMBOL_ARROWUP);
        ObjectSet(sObj+"_"+dtTime, OBJPROP_COLOR, Yellow);
        //Alert("PHG_BUY_GOOD");
      }
      break;
    case 2: //"TCA_BUY_GOOD":
      if (ObjectCreate( sObj+"_"+dtTime,OBJ_ARROW,0, dtTime, dPrice)) {
        ObjectSet(sObj+"_"+dtTime, OBJPROP_ARROWCODE, 241 ); //SYMBOL_ARROWUP);
        ObjectSet(sObj+"_"+dtTime, OBJPROP_COLOR, Yellow);
        //Alert("PHG_BUY_GOOD");
      }
    break;
    case 3: //221
      if (ObjectCreate( sObj+"_"+dtTime,OBJ_ARROW,0, dtTime, dPrice)) {
        ObjectSet(sObj+"_"+dtTime, OBJPROP_ARROWCODE, 221 ); //SYMBOL_ARROWUP);
        ObjectSet(sObj+"_"+dtTime, OBJPROP_COLOR, Yellow);
        //Alert("PHG_BUY_GOOD");
      }
    case 4: //217
      if (ObjectCreate( sObj+"_"+dtTime,OBJ_ARROW,0, dtTime, dPrice)) {
        ObjectSet(sObj+"_"+dtTime, OBJPROP_ARROWCODE, 217 ); //SYMBOL_ARROWUP);
        ObjectSet(sObj+"_"+dtTime, OBJPROP_COLOR, Yellow);
        //Alert("PHG_BUY_GOOD");
      }
      break;
    case 5: //200
      if (ObjectCreate( sObj+"_"+dtTime,OBJ_ARROW,0, dtTime, dPrice)) {
        ObjectSet(sObj+"_"+dtTime, OBJPROP_ARROWCODE, 200 ); //SYMBOL_ARROWUP);
        ObjectSet(sObj+"_"+dtTime, OBJPROP_COLOR, OrangeRed );
        //Alert("PHG_BUY_GOOD");
      }
      break;

    
    case 31: // "PHG_SELL_GOOD":
      if (ObjectCreate( sObj+"_"+dtTime,OBJ_ARROW,0, dtTime, dPrice)) {
        ObjectSet(sObj+"_"+dtTime, OBJPROP_ARROWCODE, 234); //SYMBOL_ARROWDOWN);
        ObjectSet(sObj+"_"+dtTime, OBJPROP_COLOR, Yellow);
        //lert("PHG_SELL_GOOD");
      }
      break;
    case 32: // "PHG_SELL_GOOD":
      if (ObjectCreate( sObj+"_"+dtTime,OBJ_ARROW,0, dtTime, dPrice)) {
        ObjectSet(sObj+"_"+dtTime, OBJPROP_ARROWCODE, 242); //SYMBOL_ARROWDOWN);
        ObjectSet(sObj+"_"+dtTime, OBJPROP_COLOR, Yellow);
        //lert("PHG_SELL_GOOD");
      }
      break;
    case 33: //222
      if (ObjectCreate( sObj+"_"+dtTime,OBJ_ARROW,0, dtTime, dPrice)) {
        ObjectSet(sObj+"_"+dtTime, OBJPROP_ARROWCODE, 222); //SYMBOL_ARROWDOWN);
        ObjectSet(sObj+"_"+dtTime, OBJPROP_COLOR, Yellow);
        //lert("PHG_SELL_GOOD");
      }
    
    case 34: //218
      if (ObjectCreate( sObj+"_"+dtTime,OBJ_ARROW,0, dtTime, dPrice)) {
        ObjectSet(sObj+"_"+dtTime, OBJPROP_ARROWCODE, 218); //SYMBOL_ARROWDOWN);
        ObjectSet(sObj+"_"+dtTime, OBJPROP_COLOR, Yellow);
        //lert("PHG_SELL_GOOD");
      }
    case 35: //202
      if (ObjectCreate( sObj+"_"+dtTime,OBJ_ARROW,0, dtTime, dPrice)) {
        ObjectSet(sObj+"_"+dtTime, OBJPROP_ARROWCODE, 202); //SYMBOL_ARROWDOWN);
        ObjectSet(sObj+"_"+dtTime, OBJPROP_COLOR, OrangeRed);
        //lert("PHG_SELL_GOOD");
      }
    
      break;
     
    case 99: //"PHG_xxx_FAILED_RC:"
      if (ObjectCreate( sObj+"_"+dtTime,OBJ_ARROW,0, dtTime, dPrice)) {
        ObjectSet(sObj+"_"+dtTime, OBJPROP_ARROWCODE, 76); //SYMBOL_STOPSIGN);
        ObjectSet(sObj+"_"+dtTime, OBJPROP_COLOR, Yellow);
        //Alert("PHG_SELL_BAD");
      }
    
  }
}





string fGetComment(bool EA1, bool EA2,bool EA3, bool EA4, bool EA5, bool EA7, bool EAS, int Op) {
  if(EA1) return("<1>");
  if(EA2) return("<2>");
  if(EA3) return("<3>");
  if(EA4) return("<4>");
  if(EA5) return("<5>");
  if(EA7) return("<7>");
  if(EAS) return("<S>");
  return("");
}

void SetLevel(string text, double level, color col1, int linestyle, int thickness, datetime startofday, string sLabel="")
{
   string linename;
   string linenameLabel;

   linename =  StringConcatenate(MagicNumber,Symbol(),Period(),"_", text ); 
   linenameLabel = linename+"_label";
   
   // create or move the horizontal line   
   if (ObjectFind(linename) != 0) {
      ObjectCreate(linename, OBJ_HLINE, 0, 0, level);
      ObjectSet(linename, OBJPROP_STYLE, linestyle);
      ObjectSet(linename, OBJPROP_COLOR, col1);
      ObjectSet(linename, OBJPROP_WIDTH, thickness);
      
      ObjectSet(linename, OBJPROP_BACK, True);
      
      ObjectCreate( linenameLabel, OBJ_TEXT, 0, startofday, level);
      ObjectSetText(linenameLabel,  sLabel, 8, "Arial", col1);

   } else {
      ObjectMove(linename     , 0, Time[0], level);
      ObjectMove(linenameLabel, 0, startofday, level);
      ObjectSetText(linenameLabel,  sLabel, 8, "Arial", col1);
   }
}

//------------------------------------------------------------------------------------------------
double fGetTakeProfit( int TpLevel, int TicketOrder, int Type, double dOpenPrice ) {
double Pips;
  
  Pips=fGetProfitLevelPips(TpLevel, TicketOrder, Type, dOpenPrice);
  
  if(Type==OP_BUY) {
    SetLevel("TP", dOpenPrice+Pips*PointValue, Blue, STYLE_DOT,1,Time[0]+Period()*3*60,"TP: "+DoubleToStr(Pips,0)+" pips");
  } else {
    SetLevel("TP", dOpenPrice-Pips*PointValue, Blue, STYLE_DOT,1,Time[0]+Period()*3*60,"TP: "+DoubleToStr(Pips,0)+" pips");
  }
  return(Pips); 
}

//------------------------------------------------------------------------------------------------
double fGetProfitLevelPips(int TpLevel, int TicketOrder, int Type, double dOpenPrice ) {

static int ForTicketOrder=0;
static double level;
static int LastMode=0;
  switch(TP.Mode) {
    case 0:
      switch(TpLevel){
        case 1: return(TPmode0.TakeProfit1);          
        case 2: return(TPmode0.TakeProfit2);          
        default: return(TPmode0.TakeProfit3);          
      }  
    break;
    case 1: //ATR
      //if(TicketOrder!=ForTicketOrder || LastMode!=TP.Mode || TpLevel==1) {
      if(TpLevel==1) {
        //LastMode = TP.Mode;
        int iR=0;
        level = 0;
        for (int i=1; i<=TPmode1.atrPeriod ; i++) {
          while(TPmode1.atrNoSundayData && TimeDayOfWeek(iTime(NULL, TPmode1.atrTimeframe, iR)) == 0) iR++;
          level += (iHigh(NULL, TPmode1.atrTimeframe, iR) - iLow(NULL, TPmode1.atrTimeframe, iR)) / PointValue;
          iR++;
        }
        level = level / TPmode1.atrPeriod;
        level = level * TPmode1.atrMultiplicator ;
        //ForTicketOrder = TicketOrder;
      }
      switch(TpLevel){
        case 1: return(level);
        case 2: return(level + TPmode1.TakeProfit2);
        default: return(level + TPmode1.TakeProfit3);
      }  
    break;
    case 2: //Green lines
      //if(TicketOrder!=ForTicketOrder || LastMode!=TP.Mode) {
      if(TpLevel==1) {
        //LastMode = TP.Mode;
        if(Type==OP_BUY) level = twosixth; else level = foursixth;
        //ForTicketOrder = TicketOrder;
      }
      switch(TpLevel){
        case 1:  return(MathAbs(level-dOpenPrice)/PointValue);
        case 2:  return(MathAbs(level-dOpenPrice)/PointValue+TPmode2.TakeProfit2);
        default: return(MathAbs(level-dOpenPrice)/PointValue+TPmode2.TakeProfit3);
      }  
    break;
    case 3: //Middle BBands
      //if(TicketOrder!=ForTicketOrder || LastMode!=TP.Mode) {
      if(TpLevel==1) {
        //LastMode = TP.Mode;
        level = BBdown+(BBup-BBdown)/2;
        //ForTicketOrder = TicketOrder;
      }
      switch(TpLevel) {
        case 1:  return(MathAbs(level-dOpenPrice)/PointValue); 
        case 2:  return(MathAbs(level-dOpenPrice)/PointValue+TPmode3.TakeProfit2); 
        default: return(MathAbs(level-dOpenPrice)/PointValue+TPmode3.TakeProfit3); 
      }  
    break;
    case 4: //Stochastic
      //if(TicketOrder!=ForTicketOrder || LastMode!=TP.Mode) {
      if(TpLevel==1) {
        //LastMode = TP.Mode;
        if(Type==OP_BUY && Sto733>=TPmode4.LevelUp) {
          level = (Bid-dOpenPrice)/PointValue - 1 ; //Current price position for TP1 to trig minus 1 pip
          //ForTicketOrder = TicketOrder;
        } else if(Type==OP_SELL && Sto733<=TPmode4.LevelDn) {
          level = (dOpenPrice-Ask)/PointValue - 1 ; //Current price position for TP1 to trig minus 1 pip
          //ForTicketOrder = TicketOrder;
        } else {
          if(Type==OP_BUY)
            level = (fivesixth-dOpenPrice)/PointValue; //Take profit to extreme SIXTH indi
          else
            level = (dOpenPrice-onesixth)/PointValue; //Take profit to extreme SIXTH indi
        }
      }
      switch(TpLevel){
        case 1:  return(level);
        case 2:  return(level+TPmode4.TakeProfit2);
        default: return(level+TPmode4.TakeProfit3);
      }  
    break;
    case 5: //Stochastic cross
      if(TpLevel==1) {
        if(Type==OP_BUY && Sto733<Sto1435)
          level = Bid;
        else if(Type==OP_SELL && Sto733>Sto1435)
          level = Ask;
        else {
          if(Type==OP_BUY)  level=fivesixth;
          if(Type==OP_SELL) level=onesixth;
        }
      }
      switch(TpLevel) {
        case 1:  return(MathAbs(level-dOpenPrice)/PointValue); 
        case 2:  return(MathAbs(level-dOpenPrice)/PointValue+TPmode5.TakeProfit2); 
        default: return(MathAbs(level-dOpenPrice)/PointValue+TPmode5.TakeProfit3); 
      }  
    break;
    
    case 6: //Upper BB
      if(TpLevel==1) {
        level = BBup;
      }
      switch(TpLevel) {
        case 1:  return(MathAbs(level-dOpenPrice)/PointValue); 
        case 2:  return(MathAbs(level-dOpenPrice)/PointValue+TPmode6.TakeProfit2); 
        default: return(MathAbs(level-dOpenPrice)/PointValue+TPmode6.TakeProfit3); 
      }  
    break;
    case 7: //Lower BB
      if(TpLevel==1) {
        level = BBdown;
      }
      switch(TpLevel) {
        case 1:  return(MathAbs(level-dOpenPrice)/PointValue); 
        case 2:  return(MathAbs(level-dOpenPrice)/PointValue+TPmode7.TakeProfit2); 
        default: return(MathAbs(level-dOpenPrice)/PointValue+TPmode7.TakeProfit3); 
      }  
    break;
    case 8: //
      if(TpLevel==1) {
        if(Type==OP_BUY && Sto733>dMACD)
          level = Bid;
        else if(Type==OP_SELL && Sto733<dMACD)
          level = Ask;
        else {
          if(Type==OP_BUY)  level=fivesixth;
          if(Type==OP_SELL) level=onesixth;
        }
      }
      switch(TpLevel) {
        case 1:  return(MathAbs(level-dOpenPrice)/PointValue); 
        case 2:  return(MathAbs(level-dOpenPrice)/PointValue+TPmode8.TakeProfit2); 
        default: return(MathAbs(level-dOpenPrice)/PointValue+TPmode8.TakeProfit3); 
      }  
    break;
  }
  
}


//------------------------------------------------------------------------------------------------
double fGetLots( int TpLevel ) {

  switch(TP.Mode) {
    case 0:
      switch(TpLevel) {
        case 1: return(TPmode0.Lots1r);
        case 2: return(TPmode0.Lots2r);
      }
    break;
    case 1:
      switch(TpLevel) {
        case 1: return(TPmode1.Lots1r);
        case 2: return(TPmode1.Lots2r);
      }
    break;
    case 2:
      switch(TpLevel) {
        case 1: return(TPmode2.Lots1r);
        case 2: return(TPmode2.Lots2r);
      }
    break;
    case 3:
      switch(TpLevel) {
        case 1: return(TPmode3.Lots1r);
        case 2: return(TPmode3.Lots2r);
      }
    break;
    case 4:
      switch(TpLevel) {
        case 1: return(TPmode4.Lots1r);
        case 2: return(TPmode4.Lots2r);
      }
    break;
    case 5:
      switch(TpLevel) {
        case 1: return(TPmode5.Lots1r);
        case 2: return(TPmode5.Lots2r);
      }
    break;
    case 6:
      switch(TpLevel) {
        case 1: return(TPmode6.Lots1r);
        case 2: return(TPmode6.Lots2r);
      }
    break;
    case 7:
      switch(TpLevel) {
        case 1: return(TPmode7.Lots1r);
        case 2: return(TPmode7.Lots2r);
      }
    break;
    case 8:
      switch(TpLevel) {
        case 1: return(TPmode8.Lots1r);
        case 2: return(TPmode8.Lots2r);
      }
    break;
  }
  return(100);

}

//-------------------------------------------------------------------------------
// WriteLog File for Panel
// DO NOT CHANGE COLUMN ORDER!
//-------------------------------------------------------------------------------
void SendDataToPanel( int Operation ){
string sLog;
int i;
  sLog = StringConcatenate(Symbol(),";", Operation,";"); //col 1
  

  //Column 2 and 3 - Price near Golden Top lines and Green lines
  if(Operation==-1) {
    //Primary SELL 
    if(Bid>fivesixth)
      sLog = StringConcatenate(sLog,ColorPrimaryGood,";"); //2=green indicator mean near
    else if((fivesixth-Bid)/PointValue <= Proximity)
      sLog = StringConcatenate(sLog, ColorPrimaryNear,";"); //1=yellow indicator mean over
    else
      sLog = StringConcatenate(sLog, ColorPrimaryNo,";"); //0=no indicator
  
    //Secondary SELL
    if(Bid>=foursixth && Bid<=(foursixth-(2*Proximity*PointValue)))
      sLog = StringConcatenate(sLog, ColorSecondaryGood,";"); //2=green indicator mean near
    else if((foursixth-Bid)/PointValue <= Proximity && (foursixth-Bid)/PointValue>0)
      sLog = StringConcatenate(sLog, ColorSecondaryNear,";"); //1=yellow indicator mean over
    else
      sLog = StringConcatenate(sLog, ColorSecondaryNo, ";"); //0=no indicator
  } else 
  if(Operation==1) {
    //Primary BUY
    if(Bid<onesixth)
      sLog = StringConcatenate(sLog, ColorPrimaryGood, ";"); //2=green indicator mean under
    else if((Bid-onesixth)/PointValue <= Proximity)
      sLog = StringConcatenate(sLog, ColorPrimaryNear,";"); //1=yellow indicator mean near
    else
      sLog = StringConcatenate(sLog, ColorPrimaryNo,";"); //0=no indicator
  
    //Secondary BUY
    if(Bid<=twosixth && Bid>=(twosixth+(2*Proximity*PointValue)))
      sLog = StringConcatenate(sLog,ColorSecondaryGood, ";"); //2=green indicator mean under
    else if((Bid-twosixth)/PointValue <= Proximity && (Bid-twosixth)/PointValue>0)
      sLog = StringConcatenate(sLog, ColorSecondaryNear, ";"); //1=yellow indicator mean near
    else
      sLog = StringConcatenate(sLog, ColorSecondaryNo, ";"); //0=no indicator
  }
    
  //Column 4 - Sto733, Sto435 and MACD over 85
  for (i = 0; i < WindowFirstVisibleBar(); i++) {
    MACD[i] = iMA(Symbol(), Period(), 12, 0, MODE_EMA, PRICE_CLOSE, i) - iMA(Symbol(), Period(), 26, 0, MODE_EMA, PRICE_CLOSE, i);
  }
  int iWFVB  = WindowFirstVisibleBar();
  int iWBPC  = WindowBarsPerChart();
  int iNbBar = MathMax(0,iWFVB - iWBPC);
  iNbBar = iWFVB - iNbBar;

  double dMin = MACD[ArrayMinimum(MACD, iNbBar, 0)];
  double dMax = MACD[ArrayMaximum(MACD, iNbBar, 0)];
  double dDiff= dMax - dMin;
  if (dDiff != 0.0) dMACD = 100.0 * (MACD[0] - dMin) / dDiff;

  if((Sto733>=85 && Sto1435>=85 && dMACD>=85 && Operation==-1) || (Sto733<=15 && Sto1435<=15 && dMACD<=15 && Operation==1 ))
    sLog = StringConcatenate(sLog, ColorRWBGood, ";"); //green, all over
  else if((Sto733>=75 && Sto1435>=75 && dMACD>=75 && Operation==-1) || (Sto733<=25 && Sto1435<=25 && dMACD<=25 && Operation==1)) 
    sLog = StringConcatenate(sLog, ColorRWBNear,";"); //yellow, all lines near the trigger
  else
    sLog = StringConcatenate(sLog, ColorRWBNo,";"); //nothing
  
  //Column 5,6 and 7 -
  //5 - MA inside BB  green when BB-MA < 33 pips, yellow between 34 and 66 or nothing if more distance
  //6 - MA outside BB green when BB-MA (same colors as column 6)
  //7 - absolute distance in pips show as a gage (0-100+ pips distance), lesser the gage, nearer the MA with BB
  double dDistanceUp = MathAbs(MA-BBup)/PointValue;
  double dDistanceDown=MathAbs(MA-BBdown)/PointValue;
  if(Operation==1) {
    //Column 5
    if(MA>=BBdown) { //inside
      if(dDistanceDown<=30) 
        sLog = StringConcatenate(sLog,ColorInside,";"); //Green
      else if(dDistanceDown>30 && dDistanceDown<66) 
        sLog = StringConcatenate(sLog,ColorInOutNear,";"); //Yellow
      else
        sLog = StringConcatenate(sLog,ColorInOutNo,";"); //Nothing
    } else 
      sLog = StringConcatenate(sLog,ColorInOutNo,";"); //Nothing
  
    //Column 6
    if(MA<BBdown) {
      if(dDistanceDown<=30) 
        sLog = StringConcatenate(sLog,ColorOutside,";"); //Green
      else if(dDistanceDown>30 && dDistanceDown<66) 
        sLog = StringConcatenate(sLog,ColorInOutNear,";"); //Yellow
      else
        sLog = StringConcatenate(sLog,ColorInOutNo,";"); //Nothing
    } else
      sLog = StringConcatenate(sLog,ColorInOutNo,";"); //Nothing
      
    //Column 7
    sLog = StringConcatenate(sLog,MathMin(dDistanceDown,100),";");
      
  } else 
  if(Operation==-1) {
    //Column 5
    if(MA<=BBup) { //inside
      if(dDistanceUp<=30) 
        sLog = StringConcatenate(sLog,ColorInside,";"); //Green
      else if(dDistanceUp>30 && dDistanceUp<66) 
        sLog = StringConcatenate(sLog,ColorInOutNear,";"); //Yellow
      else
        sLog = StringConcatenate(sLog,ColorInOutNo,";"); //Nothing
    } else 
      sLog = StringConcatenate(sLog,ColorInOutNo,";"); //Nothing
  
    //Column 6
    if(MA>BBup) {
      if(dDistanceUp<=30) 
        sLog = StringConcatenate(sLog,ColorOutside,";"); //Green
      else if(dDistanceUp>30 && dDistanceUp<66) 
        sLog = StringConcatenate(sLog,ColorInOutNear,";"); //Yellow
      else
        sLog = StringConcatenate(sLog,ColorInOutNo,";"); //Nothing
    } else
      sLog = StringConcatenate(sLog,ColorInOutNo,";"); //Nothing

    //Column 7
    sLog = StringConcatenate(sLog,MathMin(dDistanceUp,100),";");
  }
  
  //8 EA 1 - running
  if(!EA1)
    if(!EA1_completed) 
      sLog = StringConcatenate(sLog,ColorEANo,";"); //-1- nothing(empty box), or 3 for red indicator
    else
      sLog = StringConcatenate(sLog,ColorEAstopped,";"); //3 red (Stopped), EA has done the job
  else {
    if(EA1_completed && EAReentry && (OrderCountBuy+OrderCountSell)>0)
      sLog = StringConcatenate(sLog,ColorEAreentry,";"); //1 yellow, reentry
    else 
      sLog = StringConcatenate(sLog,ColorEArunning,";"); //2 ea is running waiting for order to trig
  }

  if(!EA2)
    if(!EA2_completed)
      sLog = StringConcatenate(sLog,ColorEANo,";"); 
    else
      sLog = StringConcatenate(sLog,ColorEAstopped,";");
  else {
    if(EA3_completed && EAReentry && (OrderCountBuy+OrderCountSell)>0)
      sLog = StringConcatenate(sLog,ColorEAreentry,";"); //1 yellow, reentry
    else
      sLog = StringConcatenate(sLog,ColorEArunning,";"); 
  }

  if(!EA3)
    if(!EA3_completed)
      sLog = StringConcatenate(sLog,ColorEANo,";");
    else
      sLog = StringConcatenate(sLog,ColorEAstopped,";"); 
  else {
    if(EA3_completed && EAReentry && (OrderCountBuy+OrderCountSell)>0)
      sLog = StringConcatenate(sLog,ColorEAreentry,";"); //1 yellow, reentry
    else
      sLog = StringConcatenate(sLog,ColorEArunning,";"); 
  }

  if(!EA4)
    if(!EA4_completed)
      sLog = StringConcatenate(sLog,ColorEANo,";");
    else
      sLog = StringConcatenate(sLog,ColorEAstopped,";");
  else {
    if(EA4_completed && EAReentry && (OrderCountBuy+OrderCountSell)>0)
      sLog = StringConcatenate(sLog,ColorEAreentry,";"); //1 yellow, reentry
    else
      sLog = StringConcatenate(sLog,ColorEArunning,";"); 
  }

  //12 - Number of order running
  sLog = StringConcatenate(sLog, (OrderCountSell+OrderCountBuy),";");
  
  //13 - Profit $
  sLog = StringConcatenate(sLog, (sellorderprofit+buyorderprofit),";");

  //14 - Profit pips
  sLog = StringConcatenate(sLog, (sellpips+buypips),";");

  //15 - windows handle
  sLog = StringConcatenate(sLog, (WindowHandle(Symbol(),Period())),";");
  

  if(!EA5)
    if(!EA5_completed)
      sLog = StringConcatenate(sLog,ColorEANo,";");
    else
      sLog = StringConcatenate(sLog,ColorEAstopped,";");
  else {
    if(EA5_completed && EAReentry && (OrderCountBuy+OrderCountSell)>0)
      sLog = StringConcatenate(sLog,ColorEAreentry,";"); //1 yellow, reentry
    else
      sLog = StringConcatenate(sLog,ColorEArunning,";"); 
  }

  if(!EA7)
    if(!EA7_completed)
      sLog = StringConcatenate(sLog,ColorEANo,";");
    else
      sLog = StringConcatenate(sLog,ColorEAstopped,";");
  else {
    if(EA7_completed && EAReentry && (OrderCountBuy+OrderCountSell)>0)
      sLog = StringConcatenate(sLog,ColorEAreentry,";"); //1 yellow, reentry
    else
      sLog = StringConcatenate(sLog,ColorEArunning,";"); 
  }
  
  sLog = StringConcatenate(sLog, TP.Mode,";");
  
  if(!BASKET_Use)
    sLog = StringConcatenate(sLog, "0;");
  else {
    if(BASKET_pipsGroupUse && BASKET_targetAmountUse)
      sLog = StringConcatenate(sLog, "3;");
    else if(BASKET_pipsGroupUse)
      sLog = StringConcatenate(sLog, "1;");
    else if(BASKET_targetAmountUse) 
      sLog = StringConcatenate(sLog, "2;");
    else
      sLog = StringConcatenate(sLog, "0;");
  }


  sLog = StringConcatenate(sLog, Operation,";");
  
  double DivBull0=iCustom(NULL,0,"FX5 MACD DIVERGENCE V1.0","", 12,26,9,"",false,false,false,0,0) ;
  double DivBull1=iCustom(NULL,0,"FX5 MACD DIVERGENCE V1.0","", 12,26,9,"",false,false,false,0,1) ;
  double DivBull2=iCustom(NULL,0,"FX5 MACD DIVERGENCE V1.0","", 12,26,9,"",false,false,false,0,2) ;

  double DivBear0=iCustom(NULL,0,"FX5 MACD DIVERGENCE V1.0","", 12,26,9,"",false,false,false,1,0) ;
  double DivBear1=iCustom(NULL,0,"FX5 MACD DIVERGENCE V1.0","", 12,26,9,"",false,false,false,1,1) ;
  double DivBear2=iCustom(NULL,0,"FX5 MACD DIVERGENCE V1.0","", 12,26,9,"",false,false,false,1,2) ;

  if((DivBull0!=0 && DivBull0!=EMPTY_VALUE) || (DivBull1!=0 && DivBull1!=EMPTY_VALUE) || (DivBull2!=0 && DivBull2!=EMPTY_VALUE))
    sLog = StringConcatenate(sLog,"1;");
  else if( (DivBear0!=0 && DivBear0!=EMPTY_VALUE) || (DivBear1!=0 && DivBear1!=EMPTY_VALUE) || (DivBear2!=0 && DivBear2!=EMPTY_VALUE))
    sLog = StringConcatenate(sLog,"-1;");
  else
    sLog = StringConcatenate(sLog,"0;");

  sLog = StringConcatenate(sLog, DoubleToStr((Ask-Bid)/PointValue,1),";");

  if(!EAS)
    if(!EAS_completed)
      sLog = StringConcatenate(sLog,ColorEANo,";");
    else
      sLog = StringConcatenate(sLog,ColorEAstopped,";");
  else {
    if(EAS_completed && EAReentry && (OrderCountBuy+OrderCountSell)>0)
      sLog = StringConcatenate(sLog,ColorEAreentry,";"); //1 yellow, reentry
    else
      sLog = StringConcatenate(sLog,ColorEArunning,";"); 
  }
  
  sLog = StringConcatenate(sLog,DrawDown,";");  

  sLog = StringConcatenate(sLog,"[EOT]",GlobalRegister);

  WriteToFile(sLog);
}

//-------------------------------------------------------------------
// Look for a command coming from an external application and execute it
//-------------------------------------------------------------------
bool ExecuteCommand() {
string sCmd;
string sExec;
string sPair;
string sSubCmd;
double Lot;
int TP;
int SL;

  sCmd = fGetCommand();
  if(sCmd=="") return(false);
  //Alert(sCmd);
  sExec = ExtractString(sCmd,",",1);
  //parse command
  if(sExec=="MARKETBUY" ) { //,pair,lot,SL,TP : place a market buy on specified pair (SL, TP at 0)
    msgError = "";  
    Lot = StrToDouble(ExtractString(sCmd,",",3)); SL = StrToDouble(ExtractString(sCmd,",",5)); TP = StrToDouble(ExtractString(sCmd,",",6));
    MagicNumber = StrToInteger(ExtractString(sCmd,",",4));
    PlaceBuy(Lot, SL,TP, Slippage, MagicNumber, "", false, 1, "");
  }
  if(sExec=="MARKETSELL" ){ //,pair,lot,SL,TP: place a market sell on specified pair
    msgError = "";  
    Lot = StrToDouble(ExtractString(sCmd,",",3)); SL = StrToDouble(ExtractString(sCmd,",",5)); TP = StrToDouble(ExtractString(sCmd,",",6));
    MagicNumber = StrToInteger(ExtractString(sCmd,",",4));
    PlaceSell(Lot, SL,TP, Slippage, MagicNumber, "", false, 31, "");
  }
  if(sExec=="CLOSEMOSTRECENT" ) { //,[pair|ALL] close most recent order from any pair
    msgError = "";  
    sSubCmd = ExtractString(sCmd,",",2);
    CloseMostRecent( sSubCmd );
  }
  if(sExec=="CLOSEALL" ) { //,[pair|ALL] : close all orders on all pairs
    msgError = "";  
    sSubCmd = ExtractString(sCmd,",",2);
    CloseAll( sSubCmd );
  }
  if(sExec=="CLOSEBUY" ) {//,[pair|ALL] : close all BUY orders on all pairs
    msgError = "";  
    sPair  = ExtractString(sCmd,",",2); 
    CloseBuyOrders( sPair, MagicNumber );
  }
  if(sExec=="CLOSESELL" ) { //,ALL: close all SELL orders on all pairs
    msgError = "";  
    sPair  = ExtractString(sCmd,",",2); 
    CloseSellOrders( sPair, MagicNumber );
  }
  if(sExec=="CLOSEALLPROFIT" ) { //[pair|ALL] : close all profits orders on all pair
    msgError = "";  
    sPair  = ExtractString(sCmd,",",2); 
    CloseAllProfitOrders( sPair );
  }
  if(sExec=="CLOSEOLDEST") { //, -1 | OP_BUY | OP_SELLClose the oldest order of those opens on current pair
    msgError = "";
    CloseHighestOrder(StrToInteger(ExtractString(sCmd,",",2)))  ;
  }
  if(sExec=="CLOSEALLTHENBUY" ) {  //,pair,lot,SL,TP : close all orders on specified pair and place a market buy immediately
    msgError = "";  
    sPair = ExtractString(sCmd,",",2); 
    CloseAll( sPair );
    Lot = StrToDouble(ExtractString(sCmd,",",3)); SL = StrToDouble(ExtractString(sCmd,",",4)); TP = StrToDouble(ExtractString(sCmd,",",5));
    PlaceBuy(Lot, SL,TP, Slippage, MagicNumber, "", false, 1, "");
  }
  if(sExec=="CLOSEALLTHENSELL" ) {  //,pair,lot,SL,TP : close all orders on specified pair and place a market sell immediately
    msgError = "";  
    sPair = ExtractString(sCmd,",",2); //ALL | pair
    CloseAll( sPair );
    Lot = StrToDouble(ExtractString(sCmd,",",3)); SL = StrToDouble(ExtractString(sCmd,",",4)); TP = StrToDouble(ExtractString(sCmd,",",5));
    PlaceSell(Lot, SL,TP, Slippage, MagicNumber, "", false, 1, "");
  }
  if(sExec=="CLEARSL" ) { //,[pair|ALL] : close all orders on all pairs
    msgError = "";  
    sSubCmd = ExtractString(sCmd,",",2);
    ClearSL(sSubCmd);
  }
  if(sExec=="CLEARTP" ) { //,[pair|ALL] : close all orders on all pairs
    msgError = "";  
    sSubCmd = ExtractString(sCmd,",",2);
    ClearTP(sSubCmd);
  }
  
  if(sExec=="SCREENSHOT") {
    msgError="";
    WindowScreenShot(ExtractString(sCmd,",",2)+".gif",StrToDouble(ExtractString(sCmd,",",3)), StrToDouble(ExtractString(sCmd,",",4)));
  }

  if(sExec=="PARAMSET" ) {    //, ticketid : close ticket id of specified ticket number
    msgError="";
    GlobalRegister = ExtractString(sCmd,",",2); //3=globalparam;param;value@@
    ParamGetAllRegister();
    ParamSetAllRegister();
  }
  
  if(sExec=="EASTART") { //EASTART,IdEA,Reentry,Mode
    msgError = "";
    EAReentry   = StrToInteger(ExtractString(sCmd,",",3));
    EAOrderType = StrToInteger(ExtractString(sCmd,",",4));
    Lots        = StrToDouble(ExtractString(sCmd,",",5));
    MagicNumber = StrToInteger(ExtractString(sCmd,",",6));
    EA1=false;EA2=false;EA3=false;EA4=false;EA5=false;EA7=false;EAS=false;
    EA1_completed=false;EA2_completed=false;EA3_completed=false;EA4_completed=false;EA5_completed=false;EA7_completed=false;EAS_completed=false;
    switch(StrToInteger(ExtractString(sCmd,",",2))) {
      case 1:
        EA1=True;
        break;
      case 2:
        EA2=True;
        break;
      case 3:
        EA3=True;
        break;
      case 4:
        EA4=True;
        break;
      case 5:
        EA5=True;
        break;
      case 7:
        EA7=True;
        break;
      case 20: //EAs
        EAS=True;
        break;
    }
    ParamSetAllRegister();
  }
  if(sExec=="EASTOP") { //EASTART,IdEA
    msgError = "";
    EAReentry  = false;
    EAOrderType= 0;
    switch(StrToInteger(ExtractString(sCmd,",",2))) {
      case 1:
        EA1=false;
        EA1_completed=false;
        break;
      case 2:
        EA2=false;
        EA2_completed=false;
        break;
      case 3:
        EA3=false;
        EA3_completed=false;
        break;
      case 4:
        EA4=false;
        EA4_completed=false;
        break;
      case 5:
        EA5=false;
        EA5_completed=false;
        break;
      case 7:
        EA7=false;
        EA7_completed=false;
        break;
      case 20:
        EAS=false;
        EAS_completed=false;
        break;
      default:
        EA1=false;EA2=false;EA3=false;EA4=false;EA5=false;EA7=false;EAS=false;
        EA1_completed=false;EA2_completed=false;EA3_completed=false;EA4_completed=false;EA5_completed=false;EA7_completed=false;EAS_completed=false;
    }
 
    ParamSetAllRegister();
  }
  
  
  FileDelete(Symbol()+".csv"); //delete the command after it's execution.  Act as a sempahor.
  
  return(true);

}

//-------------------------------------------------------------------
// Look for a file SYMBOL.CMD
// Read the command, look for [EOT], delete file and return command
// else return empty string
//-------------------------------------------------------------------
string fGetCommand() {
int hndlFile;
string sDataCmd;
string FileName;
  
  FileName = StringConcatenate(Symbol(),".csv");
  
  hndlFile = FileOpen(FileName,FILE_CSV|FILE_READ,"]");
  if(hndlFile==-1) {
    //Alert(GetLastError());
    return("");
  }

  sDataCmd = FileReadString(hndlFile);
  if(StringFind(sDataCmd,"[EOT",0)==-1) {
    FileClose(hndlFile);
    return("");
  }
  FileClose(hndlFile);
  
  return(sDataCmd);
}

bool CloseAll(string Pair)
{
   bool   result;
   double price;
   int    cmd,error;
//----
   int nTot;
   int i;
   
   nTot = OrdersTotal();
   for(i=nTot-1;i>=0;i--)  {
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) {
       if((OrderSymbol()==Pair || Pair=="ALL") && OrderMagicNumber()==MagicNumber) {
         cmd=OrderType();
         //---- first order is buy or sell
         if(cmd==OP_BUY || cmd==OP_SELL) {
           while(true) {
             if(cmd==OP_BUY) price= MarketInfo(Pair,MODE_BID);
             else            price= MarketInfo(Pair,MODE_ASK);
             result=OrderClose(OrderTicket(),OrderLots(),price,Slippage*PointValue/Point,CLR_NONE);
             if(result!=TRUE) { 
               error=GetLastError(); 
               msgError = StringConcatenate(msgError,"\nLastError = "+error);
             } else 
               error=0;
             if(error==135)
               RefreshRates();
             else
               break; //next
           }
         }
       }
     } else {
       msgError=StringConcatenate(msgError,"\nError when order select "+GetLastError());
       break;
     }
   } //for
//----
   return(true);
 }
 
 //|---------close sell orders

int CloseSellOrders(string Pair, int Magic)
{
  int total=OrdersTotal();

  for(int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if((OrderMagicNumber()==Magic || Magic==0) && (OrderSymbol()==Pair || Pair=="ALL"))
    {
      if(OrderType()==OP_SELL)
      {
        if(!OrderClose(OrderTicket(),OrderLots(),NormalizeDouble( MarketInfo(Pair,MODE_ASK),Digits),Slippage*(PointValue/Point))) {
          msgError = StringConcatenate(msgError,"\nError closing SELL order #",OrderTicket());
        }
      }
    }
  }
  return(0);
}

int CloseBuyOrders(string Pair, int Magic)
{
  int total=OrdersTotal();

  for (int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if((OrderMagicNumber()==Magic || Magic==0)&& (OrderSymbol()==Pair || Pair=="ALL"))
    {
      if(OrderType()==OP_BUY)
      {
        if (!OrderClose(OrderTicket(),OrderLots(),NormalizeDouble( MarketInfo(Pair,MODE_BID),Digits),Slippage*(PointValue/Point))) {
          msgError = StringConcatenate(msgError,"\nError closing BUY order #",OrderTicket());
        }
      }
    }
  }
  return(0);
}

 bool CloseAllProfitOrders(string Pair)
{
   bool   result;
   double price;
   int    cmd,error;
//----
   int nTot;
   int i;
   
   nTot = OrdersTotal();
   for(i=nTot-1;i>=0;i--)  {
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) {
       if((OrderSymbol()==Pair || Pair=="ALL") && OrderMagicNumber()==MagicNumber && OrderProfit()>0) {
         cmd=OrderType();
         //---- first order is buy or sell
         if(cmd==OP_BUY || cmd==OP_SELL) {
           while(true) {
             if(cmd==OP_BUY) price= MarketInfo(Pair,MODE_BID);
             else            price= MarketInfo(Pair,MODE_ASK);
             result=OrderClose(OrderTicket(),OrderLots(),price,Slippage*PointValue/Point,CLR_NONE);
             if(result!=TRUE) { 
               error=GetLastError(); 
               msgError = StringConcatenate(msgError,"\nLastError = "+error);
             } else 
               error=0;
             if(error==135)
               RefreshRates();
             else
               break; //next
           }
         }
       }
     } else {
       msgError=StringConcatenate(msgError,"\nError when order select "+GetLastError());
       break;
     }
   } //for
//----
   return(true);
 }

int ClearSL(string Pair)
{
  int total=OrdersTotal();

  for (int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if((OrderMagicNumber()==MagicNumber || MagicNumber==0)&& (OrderSymbol()==Pair || Pair=="ALL"))
    {
      if(!OrderModify(OrderTicket(),OrderOpenPrice(),0,OrderTakeProfit(),0) ) {
        msgError = StringConcatenate(msgError,"\nError clearing SL for order #",OrderTicket());
      }
    }
  }
  return(0);
}
int ClearTP(string Pair)
{
  int total=OrdersTotal();

  for (int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if((OrderMagicNumber()==MagicNumber || MagicNumber==0)&& (OrderSymbol()==Pair || Pair=="ALL"))
    {
      if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),0,0)) {
        msgError = StringConcatenate(msgError,"\nError clearing TP for order #",OrderTicket());
      }
    }
  }
  return(0);
}
bool CloseMostRecent(string Pair)
{
   bool   result;
   double price;
   int    cmd,error;
//----
   int nTot;
   int i;
   
   nTot = OrdersTotal();
   for(i=nTot-1;i>=0;i--)  {
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) {
       if((OrderSymbol()==Pair || Pair=="ALL") && OrderMagicNumber()==MagicNumber) {
         cmd=OrderType();
         //---- first order is buy or sell
         if(cmd==OP_BUY || cmd==OP_SELL) {
           while(true) {
             if(cmd==OP_BUY) price= MarketInfo(Pair,MODE_BID);
             else            price= MarketInfo(Pair,MODE_ASK);
             result=OrderClose(OrderTicket(),OrderLots(),price,Slippage*PointValue/Point,CLR_NONE);
             if(result!=TRUE) { 
               error=GetLastError(); 
               msgError = "LastError = "+error;
             } else 
               error=0;
             if(error==135)
               RefreshRates();
             else
               //break;
               return(true); //ordre ferme
           }
         }
       }
     } else {
       msgError="Error when order select "+GetLastError();
       break;
     }
   } //for
//----
   return(false);
 }

//--------------------------------------------------------------------------
// STRING functions
// Misc functions to manipulate Strings  
//---------------------------------------------------------------------------

//--------------------------------------------------------------------------
// ExtractString( string Source, string Separator, int occurrence)
//--------------------------------------------------------------------------
string ExtractString( string Source, string Sep, int Occ) {
int nPos=0;
int nPosEnd=0;
int nOcc=0;
string sSource;

  if(StringOccurrence(Source, Sep)==0) return(Source); //No Sep in string
  
  sSource = Source+Sep;
  while(true) {
    nPosEnd = StringFind(sSource, Sep, nPos);
    if (nPosEnd>0) {
      nOcc++;
      if (nOcc==Occ) return(StringSubstr(sSource, nPos, nPosEnd-nPos));
      nPos = nPosEnd+StringLen(Sep);
    } else {
      return("");
    }
  }
}

int StringOccurrence( string sSource, string sChar) {
int cpt=0;
  for(int i=0; i<(StringLen(sSource)-StringLen(sChar)+1); i++) {
    cpt+= (StringSubstr(sSource, i, StringLen(sChar))==sChar) ;
  }
  return(cpt);
}

//-----------------------------------------------------------------------
// PARAMETERS Routines
//-----------------------------------------------------------------------
//This function is called by the Init Procedure to reload last know config in case
//of reload of the MLFX_NH4_MANAGER2 in the chart or when MT4 is restart and charts
//are reloading.
bool ParamReloadLastKnowSetup() {
int hndlFile;
string sParamSetup;
string FileName;
  
  FileName = StringConcatenate(Symbol(),".nh4");
  
  hndlFile = FileOpen(FileName,FILE_BIN|FILE_READ);
  if(hndlFile==-1) {
    return(false); //No last know setup, back to EA default
  }

  sParamSetup = FileReadString(hndlFile, FileSize(hndlFile));
  if(StringFind(sParamSetup,"[EOT]",0)==-1) {
    FileClose(hndlFile); //Corrupted file, no delimiter in it!
    return(false); //Back to EA default
  }
  FileClose(hndlFile);
  
  GlobalRegister = ExtractString(sParamSetup,"[EOT]",2);  //Get all EA parameters
  
  ParamGetAllRegister(); //Assign to real variables
  
  return(true);

}
//-----------------------------------------------------------------------
// Registering parameters let you exchange data between the EA and the panel
// and let the user in the panel modify these parameters from outside MT4
// Value are keep in a global string variables.
// Variables:
//  sParam : parameter name
//  sValue : value converted to a string
//  nVarType: 0 to 4, define parameter type
//  sGroup : only to categorize display in the panel.  
//  Value is store like this in GlobalRegister variable:
//  sParam;;Value;Type;Group;@@
//------------------------------------------------------------------------
void ParamRegisterInit() { GlobalRegister = ""; }
void ParamRegister( string sParam, string sValue, int nVarType, string sGroup="") {
string sGlobalParam;
int nPosRegStart;
int nPosRegEnd;

  sGlobalParam = sParam; //""; StringConcatenate(Symbol(),Period(),"_",MagicNumber,"_",sParam);
  nPosRegStart = StringFind(GlobalRegister, sGlobalParam+";;",0);
  if(nPosRegStart==-1) {
    if(StringLen(GlobalRegister)!=0) GlobalRegister = StringConcatenate(GlobalRegister, "@@");
    //GlobalRegister = StringConcatenate(GlobalRegister, sGlobalParam,";",sParam,";",sValue,";",nVarType,";",sGroup);
    GlobalRegister = StringConcatenate(GlobalRegister, sGlobalParam,";;",sValue,";",nVarType,";",sGroup);
  } else {
    nPosRegEnd = StringFind(GlobalRegister, "@@", nPosRegStart);
    GlobalRegister = StringSubstr(GlobalRegister,0,MathMin(0,nPosRegStart-1))+StringConcatenate(sGlobalParam,";;",sValue,";",nVarType,";",sGroup)+StringSubstr(GlobalRegister,nPosRegEnd);
  }
}

//------------------------------------------------------------------------
string ParamGetValue( string sParam ) {
int nPosRegStart;

  nPosRegStart = ParamFind(sParam);
  if(nPosRegStart!=-1) {
    return( ExtractString(StringSubstr(GlobalRegister,nPosRegStart),";",3));
  }
  return("");
}
//------------------------------------------------------------------------
int ParamFind( string sParam ) {
  //return( StringFind(GlobalRegister, StringConcatenate(Symbol(),Period(),"_",MagicNumber,"_",sParam),0) );
  return( StringFind(GlobalRegister, sParam+";",0) );
}

//------------------------------------------------------------------------
// Register all parameters that can be externally set by the NH4 Panel v2
//------------------------------------------------------------------------
void ParamSetAllRegister() {

  ParamRegisterInit();
  ParamRegister("MagicNumber", MagicNumber,VARTYPE_NUMBER);
  ParamRegister("Lots", Lots, VARTYPE_DOUBLE);
  ParamRegister("EA#",_sep0,VARTYPE_STRING,"EA#");
  ParamRegister("EA1",EA1,VARTYPE_BOOLEAN,"EA#");
  ParamRegister("EA2",EA2,VARTYPE_BOOLEAN,"EA#");
  ParamRegister("EA3",EA3,VARTYPE_BOOLEAN,"EA#");
  ParamRegister("EA4",EA4,VARTYPE_BOOLEAN,"EA#");
  ParamRegister("EA5",EA5,VARTYPE_BOOLEAN,"EA#");
  ParamRegister("EA7",EA7,VARTYPE_BOOLEAN,"EA#");
  ParamRegister("EAS",EAS,VARTYPE_BOOLEAN,"EA#");

  ParamRegister("OrderType",_EAOrderType, VARTYPE_STRING,"EA#");
  ParamRegister("EAOrderType", EAOrderType, VARTYPE_NUMBER,"EA#");
  ParamRegister("EAReentry", EAReentry, VARTYPE_BOOLEAN,"EA#");
  ParamRegister("CloseOppositeOrder",CloseOnOppositeOrder, VARTYPE_BOOLEAN,"EA#");

  ParamRegister("TP.Mode",TP.Mode, VARTYPE_NUMBER);
  ParamRegister("TPallmode.BEpips",TPallmode.BEpips,VARTYPE_NUMBER);
  ParamRegister("TPMODE0",TPMODE0, VARTYPE_STRING,"TPMODE0");
  ParamRegister("TPmode0.TakeProfit1",TPmode0.TakeProfit1, VARTYPE_NUMBER,"TPMODE0");
  ParamRegister("TPmode0.Lots1r",TPmode0.Lots1r, VARTYPE_DOUBLE,"TPMODE0");
  ParamRegister("TPmode0.TakeProfit2",TPmode0.TakeProfit2, VARTYPE_NUMBER,"TPMODE0");
  ParamRegister("TPmode0.Lots2r",TPmode0.Lots2r,VARTYPE_DOUBLE,"TPMODE0");
  ParamRegister("TPmode0.TakeProfit3",TPmode0.TakeProfit3, VARTYPE_NUMBER,"TPMODE0");
  ParamRegister("TPMODE1",TPMODE1, VARTYPE_STRING,"TPMODE1");
  ParamRegister("TPmode1.atrTimeframe",TPmode1.atrTimeframe, VARTYPE_NUMBER,"TPMODE1");
  ParamRegister("TPmode1.atrPeriod",TPmode1.atrPeriod, VARTYPE_NUMBER,"TPMODE1");
  ParamRegister("TPmode1.atrMultiplicator",TPmode1.atrMultiplicator, VARTYPE_DOUBLE,"TPMODE1");
  ParamRegister("TPmode1.atrNoSundayData",TPmode1.atrNoSundayData, VARTYPE_BOOLEAN,"TPMODE1");
  ParamRegister("TPmode1.Lots1r",TPmode1.Lots1r, VARTYPE_DOUBLE,"TPMODE1");
  ParamRegister("TPmode1.TakeProfit2",TPmode1.TakeProfit2, VARTYPE_NUMBER,"TPMODE1");
  ParamRegister("TPmode1.Lots2r",TPmode1.Lots2r, VARTYPE_DOUBLE,"TPMODE1");
  ParamRegister("TPmode1.TakeProfit3",TPmode1.TakeProfit3, VARTYPE_NUMBER,"TPMODE1");
  ParamRegister("TPMODE2",TPMODE2, VARTYPE_STRING,"TPMODE2");
  ParamRegister("TPmode2.Lots1r",TPmode2.Lots1r, VARTYPE_DOUBLE,"TPMODE2");
  ParamRegister("TPmode2.TakeProfit2",TPmode2.TakeProfit2, VARTYPE_NUMBER,"TPMODE2");
  ParamRegister("TPmode2.Lots2r",TPmode2.Lots2r, VARTYPE_DOUBLE,"TPMODE2");
  ParamRegister("TPmode2.TakeProfit3",TPmode2.TakeProfit3, VARTYPE_NUMBER,"TPMODE2");
  ParamRegister("TPMODE3",TPMODE3, VARTYPE_STRING,"TPMODE3");
  ParamRegister("TPmode3.Lots1r",TPmode3.Lots1r, VARTYPE_DOUBLE,"TPMODE3");
  ParamRegister("TPmode3.TakeProfit2",TPmode3.TakeProfit2, VARTYPE_NUMBER,"TPMODE3");
  ParamRegister("TPmode3.Lots2r",TPmode3.Lots2r, VARTYPE_DOUBLE,"TPMODE3");
  ParamRegister("TPmode3.TakeProfit3",TPmode3.TakeProfit3, VARTYPE_NUMBER,"TPMODE3");
  ParamRegister("TPMODE4",TPMODE4, VARTYPE_STRING,"TPMODE4");
  ParamRegister("TPmode4.LevelUp",TPmode4.LevelUp, VARTYPE_NUMBER,"TPMODE4");
  ParamRegister("TPmode4.LevelDn",TPmode4.LevelDn, VARTYPE_NUMBER,"TPMODE4");
  ParamRegister("TPmode4.Lots1r",TPmode4.Lots1r, VARTYPE_DOUBLE,"TPMODE4");
  ParamRegister("TPmode4.TakeProfit2",TPmode4.TakeProfit2, VARTYPE_NUMBER,"TPMODE4");
  ParamRegister("TPmode4.Lots2r",TPmode4.Lots2r, VARTYPE_DOUBLE,"TPMODE4");
  ParamRegister("TPmode4.TakeProfit3",TPmode4.TakeProfit3, VARTYPE_NUMBER,"TPMODE4");

  ParamRegister("TPMODE5",TPMODE5, VARTYPE_STRING,"TPMODE5");
  ParamRegister("TPmode5.Lots1r",TPmode5.Lots1r, VARTYPE_DOUBLE,"TPMODE5");
  ParamRegister("TPmode5.TakeProfit2",TPmode5.TakeProfit2, VARTYPE_NUMBER,"TPMODE5");
  ParamRegister("TPmode5.Lots2r",TPmode5.Lots2r, VARTYPE_DOUBLE,"TPMODE5");
  ParamRegister("TPmode5.TakeProfit3",TPmode5.TakeProfit3, VARTYPE_NUMBER,"TPMODE5");

  ParamRegister("TPMODE6",TPMODE6, VARTYPE_STRING,"TPMODE6");
  ParamRegister("TPmode6.Lots1r",TPmode6.Lots1r, VARTYPE_DOUBLE,"TPMODE6");
  ParamRegister("TPmode6.TakeProfit2",TPmode6.TakeProfit2, VARTYPE_NUMBER,"TPMODE6");
  ParamRegister("TPmode6.Lots2r",TPmode6.Lots2r, VARTYPE_DOUBLE,"TPMODE6");
  ParamRegister("TPmode6.TakeProfit3",TPmode6.TakeProfit3, VARTYPE_NUMBER,"TPMODE6");

  ParamRegister("TPMODE7",TPMODE7, VARTYPE_STRING,"TPMODE7");
  ParamRegister("TPmode7.Lots1r",TPmode7.Lots1r, VARTYPE_DOUBLE,"TPMODE7");
  ParamRegister("TPmode7.TakeProfit2",TPmode7.TakeProfit2, VARTYPE_NUMBER,"TPMODE7");
  ParamRegister("TPmode7.Lots2r",TPmode7.Lots2r, VARTYPE_DOUBLE,"TPMODE7");
  ParamRegister("TPmode7.TakeProfit3",TPmode7.TakeProfit3, VARTYPE_NUMBER,"TPMODE7");

  ParamRegister("TPMODE8",TPMODE8, VARTYPE_STRING,"TPMODE8");
  ParamRegister("TPmode8.Lots1r",TPmode8.Lots1r, VARTYPE_DOUBLE,"TPMODE8");
  ParamRegister("TPmode8.TakeProfit2",TPmode8.TakeProfit2, VARTYPE_NUMBER,"TPMODE8");
  ParamRegister("TPmode8.Lots2r",TPmode8.Lots2r, VARTYPE_DOUBLE,"TPMODE8");
  ParamRegister("TPmode8.TakeProfit3",TPmode8.TakeProfit3, VARTYPE_NUMBER,"TPMODE8");

  ParamRegister("_SL",_SL,VARTYPE_STRING,"SL");
  ParamRegister("StopLoss", StopLoss, VARTYPE_NUMBER, "SL");
  ParamRegister("_Trailing_",_Trailing_,VARTYPE_STRING,"SL");
  ParamRegister("TS_Mode",TS_Mode,VARTYPE_NUMBER,"SL");
  ParamRegister("TS_StartAtTPLevel", TS_StartAtTPLevel, VARTYPE_NUMBER,"SL");
  ParamRegister("TS_SetBreakEvenAt",TS_SetBreakEvenAt, VARTYPE_NUMBER,"SL");
  ParamRegister("TS_LockPips",TS_LockPips, VARTYPE_NUMBER,"SL");
  ParamRegister("TSmode1.TrailingStop",TSmode1.TrailingStop, VARTYPE_NUMBER,"SL");
  ParamRegister("TSmode1.TrailingStep",TSmode1.TrailingStep, VARTYPE_NUMBER,"SL");
  ParamRegister("TSmode2.CandleTrailing",TSmode2.CandleTrailing, VARTYPE_NUMBER,"SL");

  ParamRegister("_Basket",_Basket, VARTYPE_STRING, "BASKET");
  ParamRegister("BASKET_Use",BASKET_Use, VARTYPE_BOOLEAN,"BASKET");
  ParamRegister("BASKET_pipsGroupUse",BASKET_pipsGroupUse, VARTYPE_BOOLEAN,"BASKET");
  ParamRegister("BASKET_targetpipsGroup",BASKET_targetpipsGroup, VARTYPE_NUMBER,"BASKET");
  ParamRegister("BASKET_targetAmountUse",BASKET_targetAmountUse, VARTYPE_BOOLEAN,"BASKET");
  ParamRegister("BASKET_targetAmount",BASKET_targetAmount, VARTYPE_DOUBLE,"BASKET");


}


//------------------------------------------------------------------------
// Retreive and set all parameters that can be externally set by another application
//------------------------------------------------------------------------
void ParamGetAllRegister() {

  if(ParamFind("MagicNumber")!=-1)  MagicNumber  = StrToInteger(ParamGetValue("MagicNumber"));
  if(ParamFind("Lots")!=-1)         Lots         = StrToDouble(ParamGetValue("Lots"));
  if(ParamFind("EA1")!=-1)          EA1          = StrToInteger(ParamGetValue("EA1"));
  if(ParamFind("EA2")!=-1)          EA2          = StrToInteger(ParamGetValue("EA2"));
  if(ParamFind("EA3")!=-1)          EA3          = StrToInteger(ParamGetValue("EA3"));
  if(ParamFind("EA4")!=-1)          EA4          = StrToInteger(ParamGetValue("EA4"));
  if(ParamFind("EA5")!=-1)          EA5          = StrToInteger(ParamGetValue("EA5"));
  if(ParamFind("EA7")!=-1 )         EA7          = StrToInteger(ParamGetValue("EA7"));
  if(ParamFind("EAS")!=-1 )         EAS          = StrToInteger(ParamGetValue("EAS"));

  if(ParamFind("EAOrderType")!=-1)   EAOrderType  = StrToInteger(ParamGetValue("EAOrderType"));
  if(ParamFind("EAReentry")!=-1)     EAReentry    = StrToInteger(ParamGetValue("EAReentry"));
  if(ParamFind("CloseOppositeOrder")!=-1) CloseOnOppositeOrder = StrToInteger(ParamGetValue("CloseOnOppositeOrder"));

  if(ParamFind("TP.Mode")!=-1)              TP.Mode                 = StrToInteger(ParamGetValue("TP.Mode"));
  if(ParamFind("TPallmode.BEpips")!=-1)     TPallmode.BEpips        = StrToInteger(ParamGetValue("TPallmode.BEpips"));
  if(ParamFind("TPmode0.TakeProfit1")!=-1)  TPmode0.TakeProfit1     = StrToInteger(ParamGetValue("TPmode0.TakeProfit1"));
  if(ParamFind("TPmode0.Lots1r")!=-1)       TPmode0.Lots1r          = StrToDouble(ParamGetValue("TPmode0.Lots1r"));
  if(ParamFind("TPmode0.TakeProfit2")!=-1)  TPmode0.TakeProfit2     = StrToInteger(ParamGetValue("TPmode0.TakeProfit2"));
  if(ParamFind("TPmode0.Lots2r")!=-1)       TPmode0.Lots2r          = StrToDouble(ParamGetValue("TPmode0.Lots2r"));
  if(ParamFind("TPmode0.TakeProfit3")!=-1)  TPmode0.TakeProfit3     = StrToInteger(ParamGetValue("TPmode0.TakeProfit3"));
  if(ParamFind("TPmode1.atrTimeframe")!=-1) TPmode1.atrTimeframe    = StrToInteger(ParamGetValue("TPmode1.atrTimeframe"));
  if(ParamFind("TPmode1.atrPeriod")!=-1)    TPmode1.atrPeriod       = StrToInteger(ParamGetValue("TPmode1.atrPeriod"));
  if(ParamFind("TPmode1.atrMultiplicator")!=-1) TPmode1.atrMultiplicator= StrToDouble(ParamGetValue("TPmode1.atrMultiplicator"));
  if(ParamFind("TPmode1.atrNoSundayData")!=-1)  TPmode1.atrNoSundayData = StrToInteger(ParamGetValue("TPmode1.atrNoSundayData"));
  if(ParamFind("TPmode1.Lots1r")!=-1)       TPmode1.Lots1r          = StrToDouble(ParamGetValue("TPmode1.Lots1r"));
  if(ParamFind("TPmode1.TakeProfit2")!=-1)  TPmode1.TakeProfit2     = StrToInteger(ParamGetValue("TPmode1.TakeProfit2"));
  if(ParamFind("TPmode1.Lots2r")!=-1)       TPmode1.Lots2r          = StrToDouble(ParamGetValue("TPmode1.Lots2r"));
  if(ParamFind("TPmode1.TakeProfit3")!=-1)  TPmode1.TakeProfit3     = StrToInteger(ParamGetValue("TPmode1.TakeProfit3"));
  if(ParamFind("TPmode2.Lots1r")!=-1)       TPmode2.Lots1r          = StrToDouble(ParamGetValue("TPmode2.Lots1r"));
  if(ParamFind("TPmode2.TakeProfit2")!=-1)  TPmode2.TakeProfit2     = StrToInteger(ParamGetValue("TPmode2.TakeProfit2"));
  if(ParamFind("TPmode2.Lots2r")!=-1)       TPmode2.Lots2r          = StrToDouble(ParamGetValue("TPmode2.Lots2r"));
  if(ParamFind("TPmode2.TakeProfit3")!=-1)  TPmode2.TakeProfit3     = StrToInteger(ParamGetValue("TPmode2.TakeProfit3"));

  if(ParamFind("TPmode3.Lots1r")!=-1)       TPmode3.Lots1r          = StrToDouble(ParamGetValue("TPmode3.Lots1r"));
  if(ParamFind("TPmode3.TakeProfit2")!=-1)  TPmode3.TakeProfit2     = StrToInteger(ParamGetValue("TPmode3.TakeProfit2"));
  if(ParamFind("TPmode3.Lots2r")!=-1)       TPmode3.Lots2r          = StrToDouble(ParamGetValue("TPmode3.Lots2r"));
  if(ParamFind("TPmode3.TakeProfit3")!=-1)  TPmode3.TakeProfit3     = StrToInteger(ParamGetValue("TPmode3.TakeProfit3"));

  if(ParamFind("TPmode4.LevelUp")!=-1)      TPmode4.LevelUp         = StrToInteger(ParamGetValue("TPmode4.LevelUp"));
  if(ParamFind("TPmode4.LevelDn")!=-1)      TPmode4.LevelDn         = StrToInteger(ParamGetValue("TPmode4.LevelDn"));
  if(ParamFind("TPmode4.Lots1r")!=-1)       TPmode4.Lots1r          = StrToDouble(ParamGetValue("TPmode4.Lots1r"));
  if(ParamFind("TPmode4.TakeProfit2")!=-1)  TPmode4.TakeProfit2     = StrToInteger(ParamGetValue("TPmode4.TakeProfit2"));
  if(ParamFind("TPmode4.Lots2r")!=-1)       TPmode4.Lots2r          = StrToDouble(ParamGetValue("TPmode4.Lots2r"));
  if(ParamFind("TPmode4.TakeProfit3")!=-1)  TPmode4.TakeProfit3     = StrToInteger(ParamGetValue("TPmode4.TakeProfit3"));

  if(ParamFind("TPmode5.Lots1r")!=-1)       TPmode5.Lots1r          = StrToDouble(ParamGetValue("TPmode5.Lots1r"));
  if(ParamFind("TPmode5.TakeProfit2")!=-1)  TPmode5.TakeProfit2     = StrToInteger(ParamGetValue("TPmode5.TakeProfit2"));
  if(ParamFind("TPmode5.Lots2r")!=-1)       TPmode5.Lots2r          = StrToDouble(ParamGetValue("TPmode5.Lots2r"));
  if(ParamFind("TPmode5.TakeProfit3")!=-1)  TPmode5.TakeProfit3     = StrToInteger(ParamGetValue("TPmode5.TakeProfit3"));

  if(ParamFind("TPmode6.Lots1r")!=-1)       TPmode6.Lots1r          = StrToDouble(ParamGetValue("TPmode6.Lots1r"));
  if(ParamFind("TPmode6.TakeProfit2")!=-1)  TPmode6.TakeProfit2     = StrToInteger(ParamGetValue("TPmode6.TakeProfit2"));
  if(ParamFind("TPmode6.Lots2r")!=-1)       TPmode6.Lots2r          = StrToDouble(ParamGetValue("TPmode6.Lots2r"));
  if(ParamFind("TPmode6.TakeProfit3")!=-1)  TPmode6.TakeProfit3     = StrToInteger(ParamGetValue("TPmode6.TakeProfit3"));

  if(ParamFind("TPmode7.Lots1r")!=-1)       TPmode7.Lots1r          = StrToDouble(ParamGetValue("TPmode7.Lots1r"));
  if(ParamFind("TPmode7.TakeProfit2")!=-1)  TPmode7.TakeProfit2     = StrToInteger(ParamGetValue("TPmode7.TakeProfit2"));
  if(ParamFind("TPmode7.Lots2r")!=-1)       TPmode7.Lots2r          = StrToDouble(ParamGetValue("TPmode7.Lots2r"));
  if(ParamFind("TPmode7.TakeProfit3")!=-1)  TPmode7.TakeProfit3     = StrToInteger(ParamGetValue("TPmode7.TakeProfit3"));

  if(ParamFind("TPmode8.Lots1r")!=-1)       TPmode8.Lots1r          = StrToDouble(ParamGetValue("TPmode8.Lots1r"));
  if(ParamFind("TPmode8.TakeProfit2")!=-1)  TPmode8.TakeProfit2     = StrToInteger(ParamGetValue("TPmode8.TakeProfit2"));
  if(ParamFind("TPmode8.Lots2r")!=-1)       TPmode8.Lots2r          = StrToDouble(ParamGetValue("TPmode8.Lots2r"));
  if(ParamFind("TPmode8.TakeProfit3")!=-1)  TPmode8.TakeProfit3     = StrToInteger(ParamGetValue("TPmode8.TakeProfit3"));

  if(ParamFind("StopLoss")!=-1)               StopLoss = StrToInteger(ParamGetValue("StopLoss"));
  if(ParamFind("TS_Mode")!=-1)                TS_Mode  = StrToInteger(ParamGetValue("TS_Mode"));
  if(ParamFind("TS_StartAtTPLevel")!=-1)      TS_StartAtTPLevel=StrToInteger(ParamGetValue("TS_StartAtTPLevel"));
  if(ParamFind("TS_SetBreakEvenAt")!=-1)      TS_SetBreakEvenAt=StrToInteger(ParamGetValue("TS_SetBreakEvenAt"));
  if(ParamFind("TS_LockPips")!=-1)            TS_LockPips=StrToInteger(ParamGetValue("TS_LockPips"));
  if(ParamFind("TSmode1.TrailingStop")!=-1)   TSmode1.TrailingStop=StrToInteger(ParamGetValue("TSmode1.TrailingStop"));
  if(ParamFind("TSmode1.TrailingStep")!=-1)   TSmode1.TrailingStep=StrToInteger(ParamGetValue("TSmode1.TrailingStep"));
  if(ParamFind("TSmode2.CandleTrailing")!=-1) TSmode2.CandleTrailing=StrToInteger(ParamGetValue("TSmode2.CandleTrailing"));

  if(ParamFind("BASKET_Use")!=-1)             BASKET_Use = StrToInteger(ParamGetValue("BASKET_Use"));
  if(ParamFind("BASKET_pipsGroupUse")!=-1)    BASKET_pipsGroupUse= StrToInteger(ParamGetValue("BASKET_pipsGroupUse"));
  if(ParamFind("BASKET_targetpipsGroup")!=-1) BASKET_targetpipsGroup= StrToInteger(ParamGetValue("BASKET_targetpipsGroup"));
  if(ParamFind("BASKET_targetAmountUse")!=-1) BASKET_targetAmountUse= StrToInteger(ParamGetValue("BASKET_targetAmountUse"));
  if(ParamFind("BASKET_targetAmount")!=-1)    BASKET_targetAmount= StrToInteger(ParamGetValue("BASKET_targetAmount"));



}

//-------------------------------------------------------
// As the author observations, return the reentry Point
// that should be consider for multi level order management
//--------------------------------------------------------
void DrawReentryLine( double FromPrice, int otype ) {
double reentryPrice=0;
int Pip;

  Pip = 200; //Default value
  
  if(StringSubstr(Symbol(),0,6)=="GBPNZD" ||
     StringSubstr(Symbol(),0,6)=="EURNZD" ||
     StringSubstr(Symbol(),0,6)=="GBPAUD" ||
     StringSubstr(Symbol(),0,6)=="GBPCAD" ||
     StringSubstr(Symbol(),0,6)=="GBPJPY") 
     Pip = 250;
  else if(StringSubstr(Symbol(),0,6)=="NZDJPY" ||
     StringSubstr(Symbol(),0,6)=="AUDCHF" ||
     StringSubstr(Symbol(),0,6)=="AUDJPY" ||
     StringSubstr(Symbol(),0,6)=="USDJPY" ||
     StringSubstr(Symbol(),0,6)=="EURUSD" || 
     StringSubstr(Symbol(),0,6)=="NZDCHF" || 
     StringSubstr(Symbol(),0,6)=="CADCHF")  
     Pip = 175;
  else if(StringSubstr(Symbol(),0,6)=="AUDNZD" ||
     StringSubstr(Symbol(),0,6)=="NZDUSD" ||
     StringSubstr(Symbol(),0,6)=="CHFJPY" ||
     StringSubstr(Symbol(),0,6)=="AUDCAD" ||
     StringSubstr(Symbol(),0,6)=="USDCAD" || 
     StringSubstr(Symbol(),0,6)=="NZDCAD" || 
     StringSubstr(Symbol(),0,6)=="AUDUSD" ||  
     StringSubstr(Symbol(),0,6)=="EURCHF" ||  
     StringSubstr(Symbol(),0,6)=="EURGBP")   
     Pip = 150;

  if(otype==OP_BUY) 
    reentryPrice = FromPrice - (Pip*PointValue);
  else
    reentryPrice = FromPrice + (Pip*PointValue);
  
  SetLevel("RE", reentryPrice , Red, STYLE_DOT,2,Time[0]+Period()*3*60,"Reentry");
  
}

  ////////////////////////////////////////////////////////////////////////////////
 /// Strategy
/// NH4 manager
/////////////////////////////////////////////////////////////////////////////////
void Strategy() {
int   iOrderPos;
int i;

double BuyLots=0;
double SellLots=0;

double firstbuyopenprice=0;
double firstsellopenprice=0;
int nlastTicketBuy=0;
int nlastTicketSell=0;
static int OriginalTicketBuy=0;
static int OriginalTicketSell=0;

static int LastSellCount=0;
static int LastBuyCount =0;

   buypips=0;
   sellpips=0;
   lastbuyopenprice=0;
   lastsellopenprice=0;
   buyorderprofit=0;
   sellorderprofit=0;
   OrderCountBuy = 0;
   OrderCountSell = 0;
   LastBuyLots=0;
   LastSellLots=0;
   
   static int TicketStep = 0;

   double SL;
   int MN;

   //------------------------------------------------------------------------
   // ENTRY Signals
   //------------------------------------------------------------------------
   fivesixth = ObjectGet("fivesixth", OBJPROP_PRICE1);
   foursixth = ObjectGet("foursixth", OBJPROP_PRICE1);
   threesixth= ObjectGet("threesixth", OBJPROP_PRICE1);
   twosixth  = ObjectGet("twosixth", OBJPROP_PRICE1);
   onesixth  = ObjectGet("onesixth", OBJPROP_PRICE1);

   MA        = iMA(Symbol(),0,1,0,MODE_LWMA, PRICE_MEDIAN,0);
   MA1       = iMA(Symbol(),0,1,0,MODE_LWMA, PRICE_MEDIAN,1);
   double MA30 = iMA(NULL, PERIOD_H4,  3, 1, MODE_LWMA, PRICE_MEDIAN,  0);
   double MA31 = iMA(NULL, PERIOD_H4,  3, 1, MODE_LWMA, PRICE_MEDIAN,  1);
   
   BBup      = iBands(Symbol(),0,25,2,0,PRICE_CLOSE,MODE_UPPER,0);
   BBdown    = iBands(Symbol(),0,25,2,0,PRICE_CLOSE,MODE_LOWER,0);
  
   MACDsignal= iCustom(Symbol(),0,"NB MACD",0,0); //Main signal
   Sto733    = iStochastic(Symbol(),0,7,3,3,MODE_LWMA,1,MODE_MAIN,0);
   Sto1435   = iStochastic(Symbol(),0,14,3,5,MODE_LWMA,1,MODE_MAIN,0);

   
   //------------------------------------------------------------------------
   // Orders Statictics
   //------------------------------------------------------------------------
   if(OrdersTotal()>0){
      for(i=0;i<OrdersTotal();i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
         {
           SL  = 0;
           if(OrderStopLoss()==0 && StopLoss!=0)
           {
             SL = StopLoss;
           }
           if(SL>0)
           {
             if(OrderType()==OP_BUY || OrderType()==OP_BUYSTOP || OrderType()==OP_BUYLIMIT) {
               SL = Bid-SL*PointValue;
             } else if(OrderType()==OP_SELL || OrderType()==OP_SELLSTOP || OrderType()==OP_SELLLIMIT) {
               SL = Ask+SL*PointValue;
             } else {
               SL = Bid-SL*PointValue;
             }
           }
           if(SL>0)
           {
             if(!OrderModify(OrderTicket(), OrderOpenPrice(), SL,0,0))
             {
               msgError = "ERROR modifying order #"+OrderTicket() +"  SL:"+DoubleToStr(SL,Digits); //" TP:"+DoubleToStr(TP,Digits);
             } else {
               OrderSelect(i,SELECT_BY_POS);
             }
           }
         }
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderCloseTime()==0){
            if(OrderType()==OP_BUY){
               OrderCountBuy++;
               lastbuyopentime=OrderOpenTime();
               lastbuyopenprice=OrderOpenPrice();
               nlastTicketBuy = OrderTicket();
               if(firstbuyopenprice==0) firstbuyopenprice=lastbuyopenprice;
               buyorderprofit=buyorderprofit+OrderProfit()+OrderCommission()+OrderSwap();
               //buypips=buypips+(OrderProfit()+OrderCommission()+OrderSwap())/(OrderLots()*10);
               buypips += (Bid-OrderOpenPrice())/PointValue ;
               BuyLots += OrderLots();
               LastBuyLots = OrderLots();
            }
            if(OrderType()==OP_SELL){
               OrderCountSell++;
               lastsellopentime  = OrderOpenTime();
               lastsellopenprice = OrderOpenPrice();
               nlastTicketSell   = OrderTicket();
               if(firstsellopenprice==0) firstsellopenprice=lastsellopenprice;
               sellorderprofit=sellorderprofit+OrderProfit()+OrderCommission()+OrderSwap();
               //sellpips=sellpips+(OrderProfit()+OrderCommission()+OrderSwap())/(OrderLots()*10);
               sellpips+= (OrderOpenPrice()-Ask)/PointValue;
               SellLots += OrderLots();
               LastSellLots = OrderLots();
            }
            //if(StringFind( OrderComment(), "ss")!=-1) GlobalBasket = true;
         }
      }
   }

   if((OrderCountSell+OrderCountBuy)==0) {
     DeleteTPline();
     DeleteBEline();
     DeleteREline();
   } else {
     if(OrderCountSell>0) DrawReentryLine( lastsellopenprice, OP_SELL);
     if(OrderCountBuy>0)  DrawReentryLine( lastbuyopenprice, OP_BUY);
   }
   
   

   //----------------------------------------------------------------------------------------------
   // BASKET MODE when more then 1 lots is active on chart
   //----------------------------------------------------------------------------------------------
   if( BASKET_Use && (OrderCountSell+OrderCountBuy)>1 )
   {
     DeleteTPline();
     double level0;
     if((BuyLots-SellLots)!=0) {
       level0 =  Bid-((Point*(sellorderprofit+buyorderprofit))/((BuyLots-SellLots)*MarketInfo(Symbol(), MODE_TICKVALUE)));
       SetLevel("BE", level0, Magenta, STYLE_DOT,1,Time[0]+Period()*3*60,"Breakeven");
     }
     
     if( (BASKET_pipsGroupUse && (sellpips+buypips)>=BASKET_targetpipsGroup) || 
         //(BASKET_targetpct>0 && (sellorderprofit+buyorderprofit)>=BASKET_targetpct*AccountBalance() ) ||
         (BASKET_targetAmountUse && (sellorderprofit+buyorderprofit)>=BASKET_targetAmount) 
       )
     {
         CloseAllOpenedOrders(MagicNumber,false); 
         return(0);
     }
   } else {
     DeleteBEline();
     //----------------------------------------------------------------------------------------------
     // Take Profit by Level
     //----------------------------------------------------------------------------------------------
     // Trailing mode activated?
     if(TS_Mode==2 && (OrderCountSell+OrderCountBuy)>0 && TSmode2.CandleTrailing>0 && TicketStep>=TS_StartAtTPLevel) TrailingPositionsByCandle( 0, TSmode2.CandleTrailing, false, 0);
     
     //ML v2 - if(TS_Mode==1 && (OrderCountSell+OrderCountBuy)>0 && TicketStep>=TS_StartAtTPLevel) BBU(MagicNumber,TS_SetBreakEvenAt, TS_LockPips, true, TSmode1.TrailingStop, TSmode1.TrailingStep );
     BBU(MagicNumber,TS_SetBreakEvenAt, TS_LockPips, (TS_Mode==1 && (OrderCountSell+OrderCountBuy)>0 && TicketStep>=TS_StartAtTPLevel), TSmode1.TrailingStop, TSmode1.TrailingStep );     
   
     double CloseLot;  
   
     if(nlastTicketBuy>0)
     {
       if(OrderSelect(nlastTicketBuy,SELECT_BY_TICKET)) {
         switch(TicketStep) {
           case 0: //first takeprofit
             OriginalTicketBuy = nlastTicketBuy;
             if( (Bid-OrderOpenPrice())/PointValue >= fGetTakeProfit(1,OriginalTicketBuy ,OP_BUY, OrderOpenPrice())) {
               CloseLot = OrderLots()*fGetLots(1)/100;
               if(CloseLot>0) { //ML v2
                 if((OrderLots()-CloseLot) < MarketInfo(Symbol(),MODE_MINLOT) ) {
                   if(OrderClose(nlastTicketBuy, OrderLots(), Bid, SlippageClose*PointValue/Point)) {
                     TicketStep=0;
                     return(0);
                   }
                 } else {
                   if(OrderClose(OriginalTicketBuy, CloseLot, Bid, SlippageClose*PointValue/Point)) {
                     nlastTicketBuy = GetNewTicketId( OP_BUY, 0 );
                     if(nlastTicketBuy>0) {
                       if(OrderModify(nlastTicketBuy,OrderOpenPrice(), NormalizeDouble(OrderOpenPrice()+TPallmode.BEpips*PointValue, Digits), OrderTakeProfit(),0)) 
                         TicketStep=1;
                     }  
                     return(0);
                   }
                 }
               } else {
                 //ML v2 - Set BE + offset
                 if(OrderModify(nlastTicketBuy,OrderOpenPrice(), NormalizeDouble(OrderOpenPrice()+TPallmode.BEpips*PointValue, Digits), OrderTakeProfit(),0)) {
                   TicketStep=1;
                   return(0);
                 }
               }
             }
           break;
           
           case 1: //second takeprofit
             if( (Bid-OrderOpenPrice())/PointValue >= fGetTakeProfit(2,OriginalTicketBuy,OP_BUY,OrderOpenPrice())) {
               CloseLot = OrderLots()*fGetLots(2)/100;
               if(CloseLot>0) {
                 if((OrderLots()-CloseLot) < MarketInfo(Symbol(),MODE_MINLOT)) {
                   if(OrderClose(nlastTicketBuy, OrderLots(), Bid, SlippageClose*PointValue/Point)) {
                     TicketStep=0;
                     return(0);
                   }
                 } else {
                   if(OrderClose(nlastTicketBuy, CloseLot, Bid, SlippageClose*PointValue/Point)) {
                     nlastTicketBuy = GetNewTicketId( OP_BUY, 0 );
                     if(nlastTicketBuy>0) {
                       if(OrderModify(nlastTicketBuy,OrderOpenPrice(), NormalizeDouble(OrderOpenPrice()+fGetTakeProfit(1, OriginalTicketBuy,OP_BUY,OrderOpenPrice())*PointValue,Digits), OrderTakeProfit(),0)) 
                         TicketStep=2;
                     }
                     return(0);
                   }
                 }
               } else {
                 //ML v2 - Set BE + offset
                 if(OrderModify(nlastTicketBuy,OrderOpenPrice(), NormalizeDouble(OrderOpenPrice()+fGetTakeProfit(1, OriginalTicketBuy,OP_BUY,OrderOpenPrice())*PointValue, Digits), OrderTakeProfit(),0)) {
                   TicketStep=2;
                   return(0);
                 }
               }
             }
           break;
           case 2: //wait til end
             if( (Bid-OrderOpenPrice())/PointValue >= fGetTakeProfit(3,OriginalTicketBuy, OP_BUY, OrderOpenPrice())) {
                 if(OrderClose(nlastTicketBuy, OrderLots(), Bid, SlippageClose*PointValue/Point)) {
                   return(0);
                 }
             }
           break;
         } //switch ticketstep
       } //if orderselect
       //return(0);
     } //if nLastTicketBuy

     if(nlastTicketSell>0) {
       if(OrderSelect(nlastTicketSell,SELECT_BY_TICKET)) {
         switch(TicketStep) {
           case 0: //first takeprofit
             OriginalTicketSell = nlastTicketSell;
             if( (OrderOpenPrice()-Ask)/PointValue >= fGetTakeProfit(1,nlastTicketSell,OP_SELL, OrderOpenPrice())) {
               CloseLot = OrderLots()*fGetLots(1)/100;
               if(CloseLot>0) { //ML v2
                 if((OrderLots()-CloseLot) < MarketInfo(Symbol(),MODE_MINLOT)) {
                   if(OrderClose(nlastTicketSell, OrderLots(), Ask, SlippageClose*PointValue/Point)) {
                     TicketStep=0;
                     return(0);
                   }
                 } else {
                   if(OrderClose(nlastTicketSell, CloseLot, Ask, SlippageClose*PointValue/Point)) {
                     nlastTicketSell = GetNewTicketId( OP_SELL, 0);
                     if(nlastTicketSell>0) {
                       if(OrderModify(nlastTicketSell,OrderOpenPrice(), NormalizeDouble(OrderOpenPrice()-TPallmode.BEpips*PointValue, Digits), OrderTakeProfit(),0)) 
                         TicketStep=1;
                     }
                     return(0);
                   }
                 }
               } else {
                 //ML v2
                 if(OrderModify(nlastTicketSell,OrderOpenPrice(), NormalizeDouble(OrderOpenPrice()-TPallmode.BEpips*PointValue, Digits), OrderTakeProfit(),0)) {
                   TicketStep=1;
                   return(0);
                 }
               }
             }
           break;
           case 1: //second takeprofit
             if( (OrderOpenPrice()-Ask)/PointValue >= fGetTakeProfit(2,OriginalTicketSell,OP_SELL, OrderOpenPrice())) {
               CloseLot = OrderLots()*fGetLots(2)/100;
               if(CloseLot>0) {
                 if((OrderLots()-CloseLot) < MarketInfo(Symbol(),MODE_MINLOT)) {
                   if(OrderClose(nlastTicketSell, OrderLots(), Ask, SlippageClose*PointValue/Point)) {
                     TicketStep=0;
                     return(0);
                   }
                 } else {
                   if(OrderClose(nlastTicketSell, CloseLot, Ask, SlippageClose*PointValue/Point)) {
                     nlastTicketSell = GetNewTicketId( OP_SELL, 0 );
                     if(nlastTicketSell>0) {
                       if(OrderModify(nlastTicketSell,OrderOpenPrice(), NormalizeDouble(OrderOpenPrice()-fGetTakeProfit(1,OriginalTicketSell,OP_SELL, OrderOpenPrice())*PointValue, Digits), OrderTakeProfit(),0)) 
                         TicketStep=2;
                     }
                     return(0);
                   }
                 }
               } else {
                 //ML v2
                 if(OrderModify(nlastTicketSell,OrderOpenPrice(), NormalizeDouble(OrderOpenPrice()-fGetTakeProfit(1,OriginalTicketSell,OP_SELL, OrderOpenPrice())*PointValue, Digits), OrderTakeProfit(),0)) {
                   TicketStep=1;
                   return(0);
                 }
               }
             }
           break;
           case 2: //wait til end
             if( (OrderOpenPrice()-Ask)/PointValue >= fGetTakeProfit(3,OriginalTicketSell,OP_SELL, OrderOpenPrice())) {
               if(OrderClose(nlastTicketSell, OrderLots(), Ask, SlippageClose*PointValue/Point)) {
                 return(0);
               }
             }
           break;
         } //switch ticketstep
       } //if orderselect
       //return(0);
     } //if nLastTicketSell
  
     //TicketStep = 0;
   } //else BASKET_Use


  string sLog;
  bool BUYme  = false;
  bool SELLme = false;

  //data pushed to the panel
  int Operation=0;
  if((threesixth-Bid)>0) 
    Operation = 1; //bottom, then buy
  else 
    Operation = -1;  //top, then sell

  //--------------------------------------------------------------------------------------
  // EAs
  //--------------------------------------------------------------------------------------
  if(EA1) {
    BUYme  =  Ask < BBdown ;
    SELLme =  Bid > BBup;
  }
  if(EA2) {
    BUYme  = MA > BBdown ;
    SELLme = MA < BBup;
  }
  if(EA3) {
    BUYme  = Ask < iMA(NULL, PERIOD_H4, 4, 0, MODE_LWMA, PRICE_LOW,  0) && MA>BBdown ;
    SELLme = Bid > iMA(NULL, PERIOD_H4, 4, 0, MODE_LWMA, PRICE_HIGH,  0) && MA < BBup ;
  }  
  if(EA4) {
    BUYme  = Ask < BBdown || (Ask > MA30 && MA30 > MA);
    SELLme = Bid > BBup   || (Bid < MA30 && MA30 < MA);
  }
  if(EA5) {  
    BUYme  = Ask > MA30 && MA31 > MA;
    SELLme = Bid < MA30 && MA31 < MA;
  }
  if(EA7) {
    double BbLower  = iBands(NULL, PERIOD_H4,  25, 2, 3, PRICE_CLOSE, MODE_LOWER, 0); 
    double BbLower1 = iBands(NULL, PERIOD_H4,  25, 2, 3, PRICE_CLOSE, MODE_LOWER, 1); 
    double BbUpper  = iBands(NULL, PERIOD_H4,  25, 2, 3, PRICE_CLOSE, MODE_UPPER, 0);
    double BbUpper1 = iBands(NULL, PERIOD_H4,  25, 2, 3, PRICE_CLOSE, MODE_UPPER, 1); 

    BUYme  = Ask > BbLower && BbLower1 > MA  ; 
    SELLme = Bid < BbUpper && BbUpper1 < MA  ;
  }
  if(EAS) {
    BUYme  = MA > MA30 && Sto733>15 && Ask>Open[0];
    SELLme = MA < MA30 && Sto733<85 && Bid<Open[0];
  }
  
  BUYme  = BUYme && Operation==1 && SpreadOK()   && EAOrderType!=2;
  SELLme = SELLme && Operation==-1 && SpreadOK() && EAOrderType!=1;
  //--------------------------------------------------------------------------------------


    //-------------------------------------------------------
    // PLACING ORDER
    //-------------------------------------------------------
    double LotsA;
    double TPauto;
    double SLauto;
    string sLevel;

    //-------------------------------------------
    //Place BUY Order?
    if (BUYme && ((OrderCountBuy==0 && EAReentry) || (!EAReentry))) {
      
      if(CloseOnOppositeOrder) CloseSellOrders(Symbol(), MagicNumber);
      
      SLauto = StopLoss;        
      if (PlaceBuy( Lots , SLauto, TPauto, Slippage, MagicNumber, prefix, true,1, fGetComment(EA1,EA2,EA3,EA4,EA5,EA7,EAS, Operation))>0 ) {
        if(EA1) EA1_completed = true;
        if(EA2) EA2_completed = true;
        if(EA3) EA3_completed = true;
        if(EA4) EA4_completed = true;
        if(EA5) EA5_completed = true;
        if(EA7) EA7_completed = true;
        if(EAS) EAS_completed = true;
        if(!EAReentry) {
          EA1 = false;
          EA2 = false;
          EA3 = false;
          EA4 = false;
          EA5 = false;
          EA7 = false;
          EAS = false;
        }
        TicketStep=0;
        PanelDelay = 0; //Refresh panel now!
      }
    }

    //-------------------------------------------
    //Place SELL Order? 
    if (SELLme && ((OrderCountSell==0 && EAReentry) || (!EAReentry))) {
      if(CloseOnOppositeOrder) CloseBuyOrders(Symbol(), MagicNumber);
      SLauto = StopLoss;
      if (PlaceSell( Lots, SLauto, TPauto, Slippage, MagicNumber, prefix, true,31, fGetComment(EA1,EA2,EA3,EA4,EA5,EA7,EAS, Operation))>0 ) {
        if(EA1) EA1_completed = true;
        if(EA2) EA2_completed = true;
        if(EA3) EA3_completed = true;
        if(EA4) EA4_completed = true;
        if(EA5) EA5_completed = true;
        if(EA7) EA7_completed = true;
        if(EAS) EAS_completed = true;
        if(!EAReentry) {
          EA1 = false;
          EA2 = false;
          EA3 = false;
          EA4 = false;
          EA5 = false;
          EA7 = false;
          EAS = false;
        }
        TicketStep=0;
        PanelDelay = 0; //Refresh panel now!
      }
    }
    
    msgMisc = StringConcatenate(msgMisc,"\n",msg);

    if((TimeCurrent()-PanelLastInfoSent)>=PanelDelay) {
      SendDataToPanel(Operation);   //Push internal status and parameters to Panel
      PanelDelay = PanelDelayStart; //Reassign to initial delay in case of direct refresh
      PanelLastInfoSent = TimeCurrent();
    }  
 
}


